/* 
 * 
 * eulerGlyphs v0.9.0
 * 
 * 2013-12-18
 *
 * 
 * 
 * eulerGlyphs -- Drawing Area-Proportional Euler Diagrams With Glyphs	    
 * 		http://www.eulerdiagrams.org/eulerGlyphs
 * 
 * 
 * 		Copyright (C) 2012-2013, Luana Micallef. 
 * 		All rights reserved.
 * 		
 * 
 * 		This file is part of eulerGlyphs.
 * 			
 * 		eulerGlyphs is free software: you can redistribute it and/or modify
 * 		it under the terms of the GNU General Public License as published 
 * 		by the Free Software Foundation, either version 3 of the License, 
 * 		or (at your option) any later version.
	
 * 		eulerGlyphs is distributed in the hope that it will be useful,
 * 		but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * 		GNU General Public License for more details.
	
 * 		A copy of the GNU General Public License is provided with 
 * 		eulerGlyphs (in a file named 'COPYING'). Alternatively, see 
 * 		<http://www.gnu.org/licenses/gpl.html>.
 * 			
 */

 


package eulerellipse;

import visstyle.HeterogeneousChannelStyle;
import visstyle.HeterogeneousChannelStyleOutline;
import visstyle.HeterogeneousChannelStyleSolid;
import visstyle.HeterogeneousChannelStyleTexture;


/**
 * To instantiate and define a visualization style for an Euler diagram drawn with ellipses
 * 
 */



public class EulerEllipseVisStyle {

	public static HeterogeneousChannelStyle[] heterogeneousChannelStyle_3Ellipses_ColourBlindSafe () {
		String[] refLabels = {"a", "b", "c"};
		
		HeterogeneousChannelStyleSolid solidRed = new HeterogeneousChannelStyleSolid(refLabels[0]);
		solidRed.setOutlineColour(HeterogeneousChannelStyle.COLOUR_COLOURBLINDSAFE_RED_DARK);
		solidRed.setFillColour(HeterogeneousChannelStyle.COLOUR_COLOURBLINDSAFE_RED_LIGHT);
		
		HeterogeneousChannelStyleSolid solidBlue = new HeterogeneousChannelStyleSolid(refLabels[1]);
		solidBlue.setOutlineColour(HeterogeneousChannelStyle.COLOUR_COLOURBLINDSAFE_BLUE_DARK);
		solidBlue.setFillColour(HeterogeneousChannelStyle.COLOUR_COLOURBLINDSAFE_BLUE_LIGHT);
		
		HeterogeneousChannelStyleOutline outlineBlack = new HeterogeneousChannelStyleOutline(refLabels[2]);
		outlineBlack.setOutlineColour(HeterogeneousChannelStyle.COLOUR_COLOURBLINDSAFE_BLACK);
		
		return (new HeterogeneousChannelStyle[]{solidRed, solidBlue, outlineBlack});
	}
	
	public static HeterogeneousChannelStyle[] heterogeneousChannelStyle_3Ellipses (boolean colourBlindSafe) {
		if (colourBlindSafe){
			return heterogeneousChannelStyle_3Ellipses_ColourBlindSafe();
		} else {
			return (new HeterogeneousChannelStyle[]{new HeterogeneousChannelStyleSolid("a"), new HeterogeneousChannelStyleTexture("b"), new HeterogeneousChannelStyleOutline("c")});
		}
	}
}
