/* 
 * 
 * eulerGlyphs v0.9.0
 * 
 * 2013-12-18
 *
 * 
 * 
 * eulerGlyphs -- Drawing Area-Proportional Euler Diagrams With Glyphs	    
 * 		http://www.eulerdiagrams.org/eulerGlyphs
 * 
 * 
 * 		Copyright (C) 2012-2013, Luana Micallef. 
 * 		All rights reserved.
 * 		
 * 
 * 		This file is part of eulerGlyphs.
 * 			
 * 		eulerGlyphs is free software: you can redistribute it and/or modify
 * 		it under the terms of the GNU General Public License as published 
 * 		by the Free Software Foundation, either version 3 of the License, 
 * 		or (at your option) any later version.
	
 * 		eulerGlyphs is distributed in the hope that it will be useful,
 * 		but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * 		GNU General Public License for more details.
	
 * 		A copy of the GNU General Public License is provided with 
 * 		eulerGlyphs (in a file named 'COPYING'). Alternatively, see 
 * 		<http://www.gnu.org/licenses/gpl.html>.
 * 			
 */

 


package uicomponent.utils.table;

/**
 * 
 * Table Utilities
 *
 */


import javax.swing.JTable;

public class JTableUtils {
	

	public static Object GetCellData(JTable table, int row_index, int col_index){
		return table.getModel().getValueAt(row_index, col_index);
	} 
	
	public static Object[] GetColumnData(JTable table, int col_index){
		
		int rowCount = table.getRowCount();
		Object[] colData = new Object[rowCount];
		
		for (int row_index = 0; row_index < rowCount; row_index++){
			colData[row_index] = GetCellData(table, row_index, col_index);
		}
		
		return colData;
	} 
	
	public static Object[] GetColumnData(JTable table, int col_index, int[] reqRows){
		
		int rowCount = table.getRowCount();
		Object[] colData = new Object[reqRows.length];
		
		int rowIndex = 0;
		for (int i = 0; i < rowCount; i++){
			if (reqRows[rowIndex] == i){
				colData[rowIndex] = GetCellData(table, i, col_index);
				rowIndex++;
			}
		}
		
		return colData;
	} 
	
	public static Object[] GetColumnData(JTable table, int col_index, int startRowIndex, int lastInclRowIndex){
		
		int rowCount = table.getRowCount();
		Object[] colData = new Object[lastInclRowIndex-startRowIndex];
		
		for (int row_index = startRowIndex; row_index <= lastInclRowIndex; row_index++){
			colData[row_index-startRowIndex] = GetCellData(table, row_index, col_index);
		}
		
		return colData;
	} 
	
	public static Object[] GetRowData(JTable table, int row_index){
		int colCount = table.getColumnCount();
		Object[] rowData = new Object[colCount];
		
		for (int col_index = 0; col_index < colCount; col_index++){
			rowData[col_index] = GetCellData(table, row_index, col_index);
		}
		
		return rowData;
	} 
	
}
