/* 
 * 
 * eulerGlyphs v0.9.0
 * 
 * 2013-12-18
 *
 * 
 * 
 * eulerGlyphs -- Drawing Area-Proportional Euler Diagrams With Glyphs	    
 * 		http://www.eulerdiagrams.org/eulerGlyphs
 * 
 * 
 * 		Copyright (C) 2012-2013, Luana Micallef. 
 * 		All rights reserved.
 * 		
 * 
 * 		This file is part of eulerGlyphs.
 * 			
 * 		eulerGlyphs is free software: you can redistribute it and/or modify
 * 		it under the terms of the GNU General Public License as published 
 * 		by the Free Software Foundation, either version 3 of the License, 
 * 		or (at your option) any later version.
	
 * 		eulerGlyphs is distributed in the hope that it will be useful,
 * 		but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * 		GNU General Public License for more details.
	
 * 		A copy of the GNU General Public License is provided with 
 * 		eulerGlyphs (in a file named 'COPYING'). Alternatively, see 
 * 		<http://www.gnu.org/licenses/gpl.html>.
 * 			
 */

 


package uicomponent.vispanel;

import java.awt.Rectangle;
import java.awt.geom.Point2D;
import javax.swing.JPanel;


/**
 * 
 * An abstract class for visualization panels
 *
 */



public abstract class VisPanel extends JPanel {
	
	public static final Point2D.Double INNERPADDING_DEFAULT = new Point2D.Double(200,150); 
	protected Point2D.Double innerPadding = INNERPADDING_DEFAULT;
	
	
	
	
	public Rectangle getBoundingBox(){
		return (new Rectangle(0,0, this.getWidth(), this.getHeight()));
	}
	public Point2D.Double getCentreOfPanel(){
		return (new Point2D.Double (this.getWidth()/2, this.getHeight()/2));
	}
	public Point2D.Double getInnerPadding(){
		return this.innerPadding;
	}
	
	public void setInnerPadding( Point2D.Double innerPadding){
		this.innerPadding = innerPadding;
	}
	
	


	private static final long serialVersionUID = 1L;

	public abstract boolean isEmpty();
}
