/* 
 * 
 * eulerGlyphs v0.9.0
 * 
 * 2013-12-18
 *
 * 
 * 
 * eulerGlyphs -- Drawing Area-Proportional Euler Diagrams With Glyphs	    
 * 		http://www.eulerdiagrams.org/eulerGlyphs
 * 
 * 
 * 		Copyright (C) 2012-2013, Luana Micallef. 
 * 		All rights reserved.
 * 		
 * 
 * 		This file is part of eulerGlyphs.
 * 			
 * 		eulerGlyphs is free software: you can redistribute it and/or modify
 * 		it under the terms of the GNU General Public License as published 
 * 		by the Free Software Foundation, either version 3 of the License, 
 * 		or (at your option) any later version.
	
 * 		eulerGlyphs is distributed in the hope that it will be useful,
 * 		but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * 		GNU General Public License for more details.
	
 * 		A copy of the GNU General Public License is provided with 
 * 		eulerGlyphs (in a file named 'COPYING'). Alternatively, see 
 * 		<http://www.gnu.org/licenses/gpl.html>.
 * 			
 */

 


package uicomponent.vispanel;

import java.awt.Dimension;


/**
 * 
 * Visualization Utilities
 *
 */



public class VisUtils {
	
	public static enum Placement {
		CENTRE { public String toString(){return "centre";}
		},
        NORTH { public String toString(){return "north";}
	    },
		SOUTH { public String toString(){return "south";}
		},
        WEST { public String toString(){return "west ";}
	    },	    
        EAST { public String toString(){return "east ";}
	    };
	    
	    public abstract String toString();
	};    
	    
	public static enum Alignment {LEFT, RIGHT, CENTRE};
	
	public static enum Orientation {
		HORIZONTAL { public String toString() {return "horizontal";}
			         public Dimension defineDimension (double side1, double side2){
						Dimension dimension = new Dimension();
						dimension.setSize(Math.max(side1, side2), Math.min(side1, side2));
						return dimension;
				     }
		}, 
		VERTICAL { public String toString() {return "vertical";}
                   public Dimension defineDimension (double side1, double side2){
						Dimension dimension = new Dimension();
						dimension.setSize(Math.min(side1, side2), Math.max(side1, side2));
						return dimension;
				   }
		};
		
		public abstract String toString();
		public abstract Dimension defineDimension (double side1, double side2); 
	};
}
