package uicomponent.viswindow;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.font.FontRenderContext;
import java.awt.geom.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.DefaultCellEditor;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.EtchedBorder;
import javax.swing.border.LineBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;

import com.sun.java.swing.plaf.windows.WindowsLookAndFeel;

import org.dyno.visual.swing.layouts.Constraints;
import org.dyno.visual.swing.layouts.GroupLayout;
import org.dyno.visual.swing.layouts.Leading;

import pictograph.IconDisplay;
import pictograph.IconSet;
import pictograph.IconDisplay.Direction_Icons_IconRows;
import pictograph.IconDisplay.IconsPlacementStyle;
import pictograph.IconSet.IconShape;

import uicomponent.utils.UIComponentUtils;
import uicomponent.utils.panel.JPanelUtils;
import uicomponent.utils.table.JTableUtils;
import uicomponent.utils.table.editor.DoubleEditor;
import uicomponent.utils.table.editor.IntegerEditor;
import uicomponent.vispanel.*;
import utils.MathUtils;
import utils.TypingUtils;
import visforfallacy.*;
import visforfallacy.VisForFallacy.ShowRegionSizeMode;
import visstyle.*;
import elliptic.areaproptool.EllipseDiagram;
import elliptic.areaproptool.EllipseDiagramOps;
import eulerellipse.EulerEllipseVisStyle;


//VS4E -- DO NOT REMOVE THIS LINE!
public class Euler4FallaciesWin extends JFrame {

	/* ADDING A TAB:
	 * - add an index for the tab such as  private static final int TAB_EULERDIAGPOP2SETS = 2;
	 * - in the window construction:
	 *   - initialize a new panel:       eg. tabPanelsForGraphics[0] = new EulerEllipsePanel();
     *   - initialize a base rate class: eg. visForNegBR[0] = new EulerPop1SetForNeglectBaseRate((EulerEllipsePanel)tabPanelsForGraphics[0]);
	 *
	 * DEFINITIONS
	 * - Constraint (horizontal alignment, vertical alignment) 
	 * - Leading (starting position, size, min size, preferred size)
	 *
	 */

	private static final int TAB_EULERDIAGPOP1SET = 0;
	private static final int TAB_EULERDIAGPOP2SETS_CONTAINED = 1;
	private static final int TAB_EULERDIAGPOP2SETS = 2;
    private static final int TAB_ICONDISPLAY = 3;
    
    /* use these when TAB_EULERPOP1SET_ICONS is enabled
    private static final int TAB_EULERPOP1SET_ICONS = 4;
    private static final int TAB_EULERPOP2SETS_ICONS = 5; 
	private static final int TABS_COUNT = 6;
	private final String[] tabPanelsForGraphicsTitles = new String[]{"AP ED 1-Set Pop", "AP ED 2-Set Pop (contained)", "AP ED 2-Set Pop (disconnected)", "Frequency Grid", "ED 1-Set Pop + Glyphs", "ED 2-Set Pop + Glyphs"}; //"AP ED + Randomly Positioned Glyphs", "AP ED + Uniformly Positioned Glyphs", "Not AP ED + Frequency Grid Glyphs"
    private final String[] tabPanelsForGraphicsTootTipTexts = new String[]{"Area-Proportional Euler Diagram with a 1-Set Population", "Area-Proportional Euler Diagram with a 2-Set Population (contained)", "Area-Proportional Euler diagram with a 2-Set Population (disconnected)", "Frequency Grid", "Euler Diagram with a 1-Set Population and Glyphs", "Euler Diagram with a 2-Set Population and Glyphs"};
    private final int[] tabPanelsForGraphicsMnemonics = new int[]{KeyEvent.VK_1, KeyEvent.VK_2, KeyEvent.VK_3, KeyEvent.VK_4, KeyEvent.VK_5, KeyEvent.VK_6};
	*/
    private static final int TAB_EULERPOP2SETS_ICONS = 4;
	private static final int TABS_COUNT = 5;
	private final String[] tabPanelsForGraphicsTitles = new String[]{"AP ED 1-Set Pop", "AP ED 2-Set Pop (contained)", "AP ED 2-Set Pop (disconnected)", "Frequency Grid", "ED 2-Set Pop + Glyphs"}; //"AP ED + Randomly Positioned Glyphs", "AP ED + Uniformly Positioned Glyphs", "Not AP ED + Frequency Grid Glyphs"
    private final String[] tabPanelsForGraphicsTootTipTexts = new String[]{"Area-Proportional Euler Diagram with a 1-Set Population", "Area-Proportional Euler Diagram with a 2-Set Population (contained)", "Area-Proportional Euler diagram with a 2-Set Population (disconnected)", "Frequency Grid", "Euler Diagram with a 2-Set Population and Glyphs"};
    private final int[] tabPanelsForGraphicsMnemonics = new int[]{KeyEvent.VK_1, KeyEvent.VK_2, KeyEvent.VK_3, KeyEvent.VK_4, KeyEvent.VK_5};


	private static final int TABLEINPUTPROBABS_PROBABS_COLUMN = 1;
	//private static final int TABLEINPUTPROBABS_LABELS_COLUMN = 2;
    private static final int TABLEINPUTPROBABS_BASERATE_ROW = 0;
    private static final int TABLEINPUTPROBABS_TESTSENSITIVITY_ROW = 1;
    private static final int TABLEINPUTPROBABS_TESTFALSEPOSITIVE_ROW = 2;
	private final String[] tableInputProbabsRowNames = new String[]{"Base Rate", "Hit Rate", "False Alarm Rate"}; //"Test Sensitivity", "Test False Positive"};
	private final String[] tableInputProbabsRowToolTipTexts = new String[]{"+vePop","+veTest and +vePop","+veTest and -vePop"};
	private final String tableInputPopSizeRowNames = "Entire Population Size";
	private static final int TABLEVISDISPLAYOPTIONS_LABELS_COLUMN = 1;
	private static final int TABLEVISDISPLAYOPTIONS_STYLE_COLUMN = 2;

	private static final int SAVETYPE_ELD = 0;
	private static final int SAVETYPE_PNG = 1;
	private static final int SAVETYPES_COUNT = 2;
	private static final String[] saveFileTypes = new String[]{".eld", ".png"};

	private static final boolean COLOUR_BLIND_SAFE = true;


	private static final long serialVersionUID = 1L;


	private int winWidth;
	private int winHeight;	
	private Font font;
	private AffineTransform affinetransform;     
	private FontRenderContext context; 
	
	private JSplitPane splitPaneGraphicsControls;
	private JTabbedPane tabContainerForGraphics;
	private JPanel[] tabPanelsForGraphics = new JPanel[TABS_COUNT];
	private JPanel panelControls;
	private JScrollPane scrollTableInputProbabs;
	private JTable tableInputProbabs;
	private JScrollPane scrollTableInputPopSize;
	private JTable tableInputPopSize;
	private JScrollPane[] scrollVisDisplayOptions = new JScrollPane[TABS_COUNT];
	private JTable[] tableVisDisplayOptions = new JTable[TABS_COUNT];

	private JPanel panelVisSettingsIcons;
	private JLabel labelVisSettingsIcons;
	private ButtonGroup radiobtngrpIconShape;
	private JPanel panelradiobtnsIconShape;
	private JLabel labelIconShape;
	private JRadioButton[] radiobtnIconShape = new JRadioButton[IconSet.IconShape.values().length];
	private ButtonGroup radiobtngrpIconDisplayRect;
	private JPanel panelradiobtnsIconDisplayRect;
	private JLabel labelIconDisplayRect;
	private JRadioButton[] radiobtnIconDisplayRect = new JRadioButton[VisUtils.Orientation.values().length+1];
	private JTextField textIconDisplayRectIconsPerRow;
	private ButtonGroup radiobtngrpDirection;
	private JPanel panelradiobtnsDirection;
	private JLabel labelDirection;
	private JRadioButton[] radiobtnDirection = new JRadioButton[IconDisplay.Direction_Icons_IconRows.values().length];
	private ButtonGroup radiobtngrpIconPlacementStyle;
	private JPanel panelradiobtnsIconPlacementStyle;
	private JLabel labelIconPlacementStyle;
	private JRadioButton[] radiobtnIconPlacementStyle = new JRadioButton[IconDisplay.IconsPlacementStyle.values().length];
	private JLabel labelGroupIcons;
	private JTextField textGroupingValue;

	private JPanel panelVisSettingsEuler1Pop;
	private JLabel labelVisSettingsEuler1Pop;
	private JCheckBox chkboxShowPopAsRect;
	private JLabel labelPlacementOfContainedDiagram;
	private ButtonGroup radiobtngrpPlacementOfContainedDiagram;
	private JPanel panelradiobtnsPlacementOfContainedDiagram;
	private JRadioButton[] radiobtnPlacementOfContainedDiagram = new JRadioButton[VisUtils.Placement.values().length];

	private JPanel panelVisSettingsCombinedDisplays;
	private JLabel labelVisSettingsCombinedDisplays;
	private JLabel labelVisSettingsCombinedDisplaysIconPos;
	private ButtonGroup radiobtngrpCombinedDiagIconPosOpts;
	private JRadioButton[] radiobtnCombinedDiagIconPosOpts = new JRadioButton[EulerPop2SetsIconsForNeglectBaseRate.IconsPositioning.values().length];
	private JPanel panelradiobtnsCombinedDiagIconPosOpts;
	private JCheckBox chkboxShowAreaProportionalEulerDiagram;
	private JCheckBox chkboxCentreIconsInRectRegion;
	private JCheckBox chkboxScaleIconsInRegions;
	private JLabel labelGroupIconsCombinedDisplays;
	private JTextField textGroupingValueCombinedDisplays;

	private JPanel panelShowLabels;
	private JLabel labelLabels;
	private JCheckBox chkboxShowSetsLabel;
	private JCheckBox chkboxShowRegionSizeLabel;
	private ButtonGroup radiobtngrpShowRegionSizeLabel;
	private JPanel panelradiobtnsShowRegionSizeLabel;
	private JRadioButton radiobtnShowRegionSizeAsFreq;
	private JTextField textShowRegionSizeTotalFreq;
	private JRadioButton radiobtnShowRegionSizeAsProbabPercent;
	private JRadioButton radiobtnShowRegionSizeAsProbabDecimal;
	private JCheckBox chkboxShowLegend;


	private JPanel panelSave;
	private JLabel labelSave;
	private JLabel labelSaveDir;
	private JLabel labelSaveName;
	private JTextField textSaveDir;
	private JTextField textSaveName;
	private JButton buttonSaveBrowse;
	private JCheckBox chkboxSaveAll;
	private JCheckBox[] chkboxesSaveTypes = new JCheckBox[SAVETYPES_COUNT];
	private JButton buttonSave;
	private JButton buttonGenerate;

	private boolean showLegend_EulerPop2SetsIcons = true;
	 
	private File selectedSaveDir;
	private String selectedSaveFileName = "";
    private int currentActiveTabIndex = TAB_EULERDIAGPOP1SET;
	private VisForNeglectBaseRate[] visForNegBR = new VisForNeglectBaseRate[TABS_COUNT];
	private VisStyle[] defaultVisStyle;
	private static final String PREFERRED_LOOK_AND_FEEL = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";

	public Euler4FallaciesWin() {
		super("Visualizations for Fallacies");
		
		BufferedImage icon=null;
		try {
			icon = ImageIO.read(getClass().getResourceAsStream("/eulerGlyphs.png"));
		} catch (IOException e) {
			e.printStackTrace();
		}
		setIconImage(icon);
	
		tabPanelsForGraphics[0] = new EulerEllipsePanel();
		tabPanelsForGraphics[1] = new EulerEllipsePanel();
		tabPanelsForGraphics[2] = new EulerEllipsePanel();
		tabPanelsForGraphics[3] = new IconDisplayPanel();
		//tabPanelsForGraphics[4] = new EulerEllipsePanel();
		tabPanelsForGraphics[4] = new EulerEllipsePanel();

		currentActiveTabIndex = TAB_EULERDIAGPOP1SET;
		visForNegBR[0] = new EulerPop1SetForNeglectBaseRate((EulerEllipsePanel)tabPanelsForGraphics[0]);
		visForNegBR[1] = new EulerPop2SetsContainedForNeglectBaseRate((EulerEllipsePanel)tabPanelsForGraphics[1]);
		visForNegBR[2] = new EulerPop2SetsForNeglectBaseRate((EulerEllipsePanel)tabPanelsForGraphics[2]);
		visForNegBR[3] = new IconDisplayForNeglectBaseRate((IconDisplayPanel)tabPanelsForGraphics[3]);
		//visForNegBR[4] = new EulerPop1SetIconsForNeglectBaseRate((EulerEllipsePanel)tabPanelsForGraphics[4], true);
		visForNegBR[4] = new EulerPop2SetsIconsForNeglectBaseRate((EulerEllipsePanel)tabPanelsForGraphics[4], true);

 	    defaultVisStyle = visForNegBR[currentActiveTabIndex].getDefaultVisStyle(COLOUR_BLIND_SAFE);

 	    font = new Font("Verdana", Font.PLAIN, 11);
		affinetransform = new AffineTransform();     
		context = new FontRenderContext(affinetransform,true,true);  
		
		showLegend_EulerPop2SetsIcons = true;
	    
		initComponents();
		
		refreshForCurrentTab();
	}

	private void refreshForCurrentTab(){
		defaultVisStyle = visForNegBR[currentActiveTabIndex].getDefaultVisStyle(COLOUR_BLIND_SAFE);


		// disable the following line and for loop and enable the second for loop if you want to have a table for every tab (that is a table for every type of visualization)
		scrollVisDisplayOptions[0].setVisible(true);
		for (int i = 1; i < TABS_COUNT; i++){
			scrollVisDisplayOptions[i].setVisible(false);
			tableVisDisplayOptions[i]=tableVisDisplayOptions[0];
		}
		/*
		for (int i = 0; i < TABS_COUNT; i++){
			//if (scrollVisDisplayOptions[i] == null){  //should not need to check this but can do it just in case
			scrollVisDisplayOptions[i].setVisible(i==currentActiveTabIndex);
			//tableVisDisplayOptions[i].setVisible(i==currentActiveTabIndex);
		}*/

		panelVisSettingsIcons.setVisible(currentActiveTabIndex==TAB_ICONDISPLAY);
		/* use these when TAB_EULERPOP1SET_ICONS is enabled
		panelVisSettingsEuler1Pop.setVisible((currentActiveTabIndex==TAB_EULERDIAGPOP1SET)||(currentActiveTabIndex==TAB_EULERDIAGPOP2SETS_CONTAINED)||(currentActiveTabIndex==TAB_EULERPOP1SET_ICONS));
		panelVisSettingsCombinedDisplays.setVisible((currentActiveTabIndex==TAB_EULERPOP1SET_ICONS)||(currentActiveTabIndex==TAB_EULERPOP2SETS_ICONS));
		*/
		panelVisSettingsEuler1Pop.setVisible((currentActiveTabIndex==TAB_EULERDIAGPOP1SET)||(currentActiveTabIndex==TAB_EULERDIAGPOP2SETS_CONTAINED));
		panelVisSettingsCombinedDisplays.setVisible((currentActiveTabIndex==TAB_EULERPOP2SETS_ICONS));


		//chkboxShowLegend.setEnabled(currentActiveTabIndex!=TAB_ICONDISPLAY);
		chkboxShowLegend.setEnabled(currentActiveTabIndex==TAB_EULERPOP2SETS_ICONS);
		chkboxShowLegend.setSelected((currentActiveTabIndex==TAB_ICONDISPLAY) || ((currentActiveTabIndex==TAB_EULERPOP2SETS_ICONS) && showLegend_EulerPop2SetsIcons));
		
		chkboxesSaveTypes[SAVETYPE_ELD].setVisible((currentActiveTabIndex==TAB_EULERDIAGPOP1SET)||(currentActiveTabIndex==TAB_EULERDIAGPOP2SETS)||(currentActiveTabIndex==TAB_EULERDIAGPOP2SETS_CONTAINED));
		
		/*
		if (chkboxSaveAll.isSelected()){
			chkboxSaveAll.setSelected((currentActiveTabIndex==TAB_EULERDIAGPOP1SET)||(currentActiveTabIndex==TAB_EULERDIAGPOP2SETS)||(currentActiveTabIndex==TAB_EULERDIAGPOP2SETS_CONTAINED));
	    }
	    chkboxSaveAll.setVisible((currentActiveTabIndex==TAB_EULERDIAGPOP1SET)||(currentActiveTabIndex==TAB_EULERDIAGPOP2SETS)||(currentActiveTabIndex==TAB_EULERDIAGPOP2SETS_CONTAINED));
	    
	    if ((currentActiveTabIndex!=TAB_EULERDIAGPOP1SET) && (currentActiveTabIndex!=TAB_EULERDIAGPOP2SETS) && (currentActiveTabIndex!=TAB_EULERDIAGPOP2SETS_CONTAINED)){
	    	chkboxSaveAll.setSelected(false);
	    	chkboxesSaveTypes[SAVETYPE_ELD].setSelected(false);
	    }
	    
	    if (!chkboxesSaveTypes[SAVETYPE_PNG].isEnabled()){
	    	chkboxesSaveTypes[SAVETYPE_PNG].setEnabled((currentActiveTabIndex!=TAB_EULERDIAGPOP1SET)&&(currentActiveTabIndex!=TAB_EULERDIAGPOP2SETS)&&(currentActiveTabIndex!=TAB_EULERDIAGPOP2SETS_CONTAINED));
		}
		if (!chkboxesSaveTypes[SAVETYPE_PNG].isSelected()){
			chkboxesSaveTypes[SAVETYPE_PNG].setSelected((currentActiveTabIndex!=TAB_EULERDIAGPOP1SET)&&(currentActiveTabIndex!=TAB_EULERDIAGPOP2SETS)&&(currentActiveTabIndex!=TAB_EULERDIAGPOP2SETS_CONTAINED));
		}
		*/
		panelControls.paintImmediately(scrollVisDisplayOptions[0].getBounds()); // index is irrelevant because the tables are on top of each other


		refreshEllipsesRefLabelAndVisStyles(currentActiveTabIndex);
	}

    private void refreshEllipsesRefLabelAndVisStyles(int tabIndex){

		// set the appropriate ref labels and vis styles for the ellipses depending whether the current euler diagram considers the population as 1-set or 2-disconnected sets
		/* use this when TAB_EULERPOP1SET_ICONS is enabled
    	int[] reqRows = ((tabIndex==TAB_EULERDIAGPOP1SET) || (tabIndex==TAB_EULERPOP1SET_ICONS)) ? (new int[]{0,1,3}) : (new int[]{1,2,3});
		*/
    	int[] reqRows = ((tabIndex==TAB_EULERDIAGPOP1SET)) ? (new int[]{0,1,3}) : (new int[]{1,2,3});
		
		visForNegBR[tabIndex].setLabels(TypingUtils.typecastObjArrayToTArray(JTableUtils.GetColumnData(tableVisDisplayOptions[tabIndex], TABLEVISDISPLAYOPTIONS_LABELS_COLUMN, reqRows), new String[]{}));
		//currVisForNegBR.setVisStyle(TypingUtils.typecastObjArrayToTArray(JTableUtils.GetColumnData(tableVisDisplayOptions[i], TABLEVISDISPLAYOPTIONS_STYLE_COLUMN, reqRows), new VisStyle[]{}));
		VisStyle[] visStylesForDiagram = TypingUtils.typecastObjArrayToTArray(JTableUtils.GetColumnData(tableVisDisplayOptions[tabIndex], TABLEVISDISPLAYOPTIONS_STYLE_COLUMN, reqRows), new VisStyle[]{});
		if (tabIndex==TAB_EULERDIAGPOP2SETS_CONTAINED){
			// swap round the first two styles to get [-vePop,+vePop,+veTest] instead of [+vePop,-vePop,+veTest] for 2-set pop contained
			visStylesForDiagram = new VisStyle[]{visStylesForDiagram[1],visStylesForDiagram[0],visStylesForDiagram[2]};
		}
		String[] vsRefs = new String[]{"a","b","c"};
		for(int j=0; j<visStylesForDiagram.length; j++){
			visStylesForDiagram[j].setRef(vsRefs[j]);
		}
		visForNegBR[tabIndex].setVisStyle(visStylesForDiagram);
    }


	private void initComponents() {
		setTitle("eulerGlyphs: Drawing Area-Proportional Euler Diagrams with Glyphs"); 
		setLayout(new GroupLayout());
		
		/* before 2012-11-14
		add(getSplitPaneGraphicsControls(), new Constraints(new Leading(7, 1435, 10, 10), new Leading(9, 850, 10, 10)));//new Leading(7, 1435, 10, 10), new Leading(9, 850, 10, 10))); //for economics problem -> for random placement since the diagram is big -> new Leading(7, 1800, 60, 10), new Leading(9, 850, 10, 10)));
		//add(getSplitPaneGraphicsControls(), new Constraints(new Leading(0, 1600, 10, 10), new Leading(9, 850, 10, 10))); //for economics problem -> random points area-prop 
		 setSize(5000, 6000); //when generating nonAP grid form leave as (5000, 6000) to get all the required icons //(1452, 869);
		*/
		//original before 2013-06-25
		
        Dimension frameDim = Toolkit.getDefaultToolkit().getScreenSize();
		double scaleFactor_width = 0.95;
		double scaleFactor_height = 0.9;
        
		winWidth = (int)(frameDim.width*scaleFactor_width);
		winHeight = (int)(frameDim.height*scaleFactor_height);
		setSize(winWidth,winHeight);
		/*
		System.out.println("w="+winWidth);
		System.out.println("h="+winHeight);
		System.out.println("fw="+frameDim.width);
		System.out.println("fh="+frameDim.height);
		*/
		add(getSplitPaneGraphicsControls(), new Constraints(new Leading(0, winWidth, 0, 0), new Leading(0, winHeight, 0, 0)));//new Leading(7, 1435, 10, 10), new Leading(9, 850, 10, 10))); //for economics problem -> for random placement since the diagram is big -> new Leading(7, 1800, 60, 10), new Leading(9, 850, 10, 10)));
		
		//add(getSplitPaneGraphicsControls(), new Constraints(new Leading(7, 1400, 10, 10), new Leading(9, 850, 10, 10)));//new Leading(7, 1435, 10, 10), new Leading(9, 850, 10, 10))); //for economics problem -> for random placement since the diagram is big -> new Leading(7, 1800, 60, 10), new Leading(9, 850, 10, 10)));
		//setSize(5000, 5000);
		
		
		//when generating nonAP grid form leave as 
		//add(getSplitPaneGraphicsControls(), new Constraints(new Leading(7, 1435, 10, 10), new Leading(9, 850, 10, 10)));
		//setSize(5000, 6000);
		// and in getSplitPaneGraphicsControls()
		// splitPaneGraphicsControls.setDividerLocation(1123);
		//to get all the required icons
		
		//when generating nonAP grid form for economics out of 1000 (for the diagram to fit on the screen) set the window size as follows 
		//add(getSplitPaneGraphicsControls(), new Constraints(new Leading(0, 1440, 10, 10), new Leading(9, 850, 10, 10)));
		//setSize(5000, 6000);
		// and in getSplitPaneGraphicsControls()
		// splitPaneGraphicsControls.setDividerLocation(1150);
		//to get all the required icons and for it to fit in the window space
		//Also, in EulerEllipsePanel line 685 set as follows
		//ellipse.setA(ellipse.getA()*scaleAxis*1.04);
		
		initRadioButtonGroups();
	}

	private void initRadioButtonGroups(){

		initRadiobtngrpPlacementOfContainedDiagram();
		initRadiobtnGrpCombinedDiagIconPosOpts();

		initRadiobtngrpIconShape();
		initRadiobtngrpIconDisplayRect();
		initRadiobtngrpDirection();
		initRadiobtngrpIconPlacementStyle();

		initRadiobtngrpShowRegionSizeLabel();
	}

	private JSplitPane getSplitPaneGraphicsControls() {
		if (splitPaneGraphicsControls == null) {
			splitPaneGraphicsControls = new JSplitPane();
			splitPaneGraphicsControls.setBorder(null);
			splitPaneGraphicsControls.setDividerLocation(winWidth-323);//1123);//1123);//1150);//1123); //for economics problem -> for random placement since the diagram is big -> (1500)
			splitPaneGraphicsControls.setOpaque(false);
			splitPaneGraphicsControls.setLeftComponent(getTabContainerGraphics());
			splitPaneGraphicsControls.setRightComponent(getPanelControls());
			splitPaneGraphicsControls.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return splitPaneGraphicsControls;
	}

	private JTabbedPane getTabContainerGraphics() {
		if (tabContainerForGraphics == null) {
			tabContainerForGraphics = new JTabbedPane();
			tabContainerForGraphics.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			tabContainerForGraphics.setForeground(Color.black);
			tabContainerForGraphics.setFont(new Font("Verdana", Font.PLAIN, 11));
			for (int i = 0; i < TABS_COUNT; i++){
				tabContainerForGraphics.addTab(tabPanelsForGraphicsTitles[i], getTabPanelForGraphics(i));
		    	//tabContainerForGraphics.setMnemonicAt(i,tabPanelsForGraphicsMnemonics[i]);
			}
			tabContainerForGraphics.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent e){
					currentActiveTabIndex = tabContainerForGraphics.getSelectedIndex();
					refreshForCurrentTab();
					//would need to update other things too
			    }
		    });
		}
		return tabContainerForGraphics;
	}

	private JPanel getTabPanelForGraphics(int tabIndex) {
		JPanel tabPanelForGraphics = tabPanelsForGraphics[tabIndex];

		//tab panels are instantiated on window creation => they can never be null and they don't have to be instantiated here

		tabPanelForGraphics.setBackground(Color.white);
		tabPanelForGraphics.setForeground(Color.white);
		tabPanelForGraphics.setToolTipText(tabPanelsForGraphicsTootTipTexts[tabIndex]);
		tabPanelForGraphics.setFont(new Font("Verdana", Font.PLAIN, 11));
		tabPanelForGraphics.add(getPanelControls());

		return tabPanelForGraphics;
	}

	private JPanel getPanelControls() {
		int spacing = 6;
		int leftmost_x = 8;
		int topmost_y = 8; //5;
		int current_y=topmost_y;
		int comp_height = 0;
		int comp_width = 0;
		if (panelControls == null) {
			
			panelControls = new JPanel();
			panelControls.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			panelControls.setForeground(new Color(240, 240, 240));
			panelControls.setToolTipText("Controls for graphics");
			panelControls.setLayout(new GroupLayout());
			/* use these when show column name
			panelControls.add(getScrollTableInputProbabs(), new Constraints(new Leading(leftmost_x, comp_width=298, comp_width, comp_width), new Leading(current_y, comp_height=90, comp_height, comp_height)));
			current_y+=spacing+comp_height; 
			panelControls.add(getScrollTableInputPopSize(), new Constraints(new Leading(leftmost_x, comp_width=298, comp_width, comp_width), new Leading(current_y, comp_height=40, comp_height, comp_height)));
			*/
			panelControls.add(getScrollTableInputProbabs(), new Constraints(new Leading(leftmost_x, comp_width=298, comp_width, comp_width), new Leading(current_y, comp_height=75, comp_height, comp_height)));
			current_y+=spacing+comp_height; 
			panelControls.add(getScrollTableInputPopSize(), new Constraints(new Leading(leftmost_x, comp_width=298, comp_width, comp_width), new Leading(current_y, comp_height=30, comp_height, comp_height)));

			current_y+=(spacing*1.1)+comp_height; //1.3
			comp_height=120; //115
			for (int i = 0; i < TABS_COUNT; i++) {
				panelControls.add(getScrollVisDisplayOptions(i), new Constraints(new Leading(leftmost_x,comp_width, comp_width, comp_width), new Leading(current_y, comp_height, comp_height, comp_height))); //(120,103, 11, 11)));
			}
			
			current_y+=(spacing*0.95); //1.3
			
			panelControls.add(getPanelVisSettingsIcons(), new Constraints(new Leading(leftmost_x, comp_width, comp_width, comp_width), new Leading(current_y+=spacing+comp_height, comp_height=204, comp_height, comp_height))); //(230, 225, 10, 10)));
			panelControls.add(getPanelVisSettingsEuler1Pop(), new Constraints(new Leading(leftmost_x, comp_width, comp_width, comp_width), new Leading(current_y, comp_height=98, comp_height, comp_height))); //(245, 65, 10, 10))); 
			//panelControls.add(getPanelVisSettingsCombinedDisplays(), new Constraints(new Leading(leftmost_x, comp_width, comp_width, comp_width), new Leading(current_y+=spacing+comp_height, comp_height=98, comp_height, comp_height)));//(320, 110, 10, 10))); //(230, 225, 10, 10)));
			panelControls.add(getPanelVisSettingsCombinedDisplays(), new Constraints(new Leading(leftmost_x, comp_width, comp_width, comp_width), new Leading(current_y, comp_height=60, comp_height, comp_height)));//(320, 110, 10, 10))); //(230, 225, 10, 10)));
			
			comp_height=35;
			panelControls.add(getButtonGenerate(), new Constraints(new Leading(leftmost_x+1, comp_width, comp_width, comp_width), new Leading(current_y=winHeight-comp_height-8, comp_height, comp_height, comp_height))); // original on big screen
			comp_height=111;
			panelControls.add(getPanelSave(), new Constraints(new Leading(leftmost_x, comp_width, comp_width, comp_width), new Leading(current_y-=(comp_height+spacing),comp_height,comp_height,comp_height)));  //(656, 127, 10, 10)));
			comp_height=173;
			panelControls.add(getPanelShowLabels(), new Constraints(new Leading(leftmost_x, comp_width, comp_width, comp_width), new Leading(current_y-=(comp_height+spacing), comp_height, comp_height, comp_height))); //new Leading(510,155,10,10))); //(480, 155, 10, 10)));			
		}
		
		return panelControls;
	}


	private JScrollPane getScrollTableInputProbabs() {
		if (scrollTableInputProbabs == null) {
			scrollTableInputProbabs = new JScrollPane();
			scrollTableInputProbabs.setBorder(new LineBorder(Color.black, 1, false));
			scrollTableInputProbabs.setViewportView(getTableInputProbabs());
			scrollTableInputProbabs.setBorder(BorderFactory.createEmptyBorder()); 
			scrollTableInputProbabs.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return scrollTableInputProbabs;
	}

	private JTable getTableInputProbabs() {

		if (tableInputProbabs == null) {

			tableInputProbabs = new JTable(){

				private static final long serialVersionUID = 1L;

				// getTootTipText does not work if placed in new DefaultTableModel
				public String getToolTipText(MouseEvent event){
					int rowIndex = tableInputProbabs.rowAtPoint(event.getPoint());
					int colIndex = tableInputProbabs.columnAtPoint(event.getPoint());
					if (colIndex  == 0){
						return tableInputProbabsRowToolTipTexts[rowIndex];
					}
					return "";
				}
			};
			
			Double[] inputs = new Double[]{0.01,0.8,0.096};
			//Double[] inputs = new Double[]{0.15,0.8,0.2};
			//Double[] inputs = new Double[]{0.3,0.7,0.5};
			
			tableInputProbabs.setColumnSelectionAllowed(true);
			tableInputProbabs.setModel(new DefaultTableModel(new Object[][] { { tableInputProbabsRowNames[0], inputs[0], },//0.3), }, //0.01), },  //0.05), }, //0.04), },     //0.15),}, //0.01), },    // new String(""), },
																			  { tableInputProbabsRowNames[1], inputs[1], },//0.7), }, //0.8), }, //0.80), }, //0.75), },     //0.8),},//0.8), },    // new String(""), },
																			  { tableInputProbabsRowNames[2], inputs[2], }, },//0.5), }, }, //0.096), }, }, //0.2), }, }, //0.125), }, }, //0.2),},},//0.096), }, }, // new String(""), }, },
															 new String[] { "", "", }) { //"label", }) {

				Class<?>[] types = new Class<?>[] { Object.class, Object.class, };//Object.class, };

				public Class<?> getColumnClass(int columnIndex) {
					return types[columnIndex];
				}

				public boolean isCellEditable(int row, int column){
					if (column == 0){
						return false;
					}
					return true;
				}
				
			});
		    tableInputProbabs.setTableHeader(null);
			
			tableInputProbabs.setRowMargin(10);
			tableInputProbabs.setAutoscrolls(false);
			tableInputProbabs.setCellSelectionEnabled(true);
			tableInputProbabs.setRowHeight(25);
			tableInputProbabs.setAlignmentY(1.0f);
			tableInputProbabs.setIntercellSpacing(new Dimension(5, 10));
			tableInputProbabs.setAutoResizeMode(JTable.AUTO_RESIZE_NEXT_COLUMN);
			tableInputProbabs.getColumnModel().getColumn(1).setCellEditor(new DoubleEditor(0,1, new Font("Verdana", Font.PLAIN, 11)));
			tableInputProbabs.setFont(new Font("Verdana", Font.PLAIN, 11));
			//tableInputProbabs.getTableHeader().setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return tableInputProbabs;
	}

	private JScrollPane getScrollTableInputPopSize() {
		if (scrollTableInputPopSize == null) {
			scrollTableInputPopSize = new JScrollPane();
			scrollTableInputPopSize.setBorder(new LineBorder(Color.black, 1, false));
			scrollTableInputPopSize.setViewportView(getTableInputPopSize());
			scrollTableInputPopSize.setBorder(BorderFactory.createEmptyBorder()); 
			scrollTableInputPopSize.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return scrollTableInputPopSize;
	}

	private JTable getTableInputPopSize() {

		if (tableInputPopSize == null) {

			tableInputPopSize = new JTable(){

				private static final long serialVersionUID = 1L;

				/*
				// getTootTipText does not work if placed in new DefaultTableModel
				public String getToolTipText(MouseEvent event){
					int rowIndex = tableInputPopSize.rowAtPoint(event.getPoint());
					int colIndex = tableInputPopSize.columnAtPoint(event.getPoint());
					if (colIndex  == 0){
						return tableInputPopSizeRowToolTipTexts[rowIndex];
					}
					return "";
				}
				*/
			};
			
			int input = 1000;
			//Double[] inputs = new Double[]{0.15,0.8,0.2};
			//Double[] inputs = new Double[]{0.3,0.7,0.5};
			
			tableInputPopSize.setColumnSelectionAllowed(true);
			tableInputPopSize.setModel(new DefaultTableModel(new Object[][] { { tableInputPopSizeRowNames, input, },},
																				new String[] { "", "", }) { //"label", }) {

				Class<?>[] types = new Class<?>[] { Object.class, Object.class, };//Object.class, };

				public Class<?> getColumnClass(int columnIndex) {
					return types[columnIndex];
				}

				public boolean isCellEditable(int row, int column){
					if (column == 0){
						return false;
					}
					return true;
				}
				
			});
		    tableInputPopSize.setTableHeader(null);
			
			tableInputPopSize.setRowMargin(10);
			tableInputPopSize.setAutoscrolls(false);
			tableInputPopSize.setCellSelectionEnabled(true);
			tableInputPopSize.setRowHeight(25);
			tableInputPopSize.setAlignmentY(1.0f);
			tableInputPopSize.setIntercellSpacing(new Dimension(5, 10));
			tableInputPopSize.setAutoResizeMode(JTable.AUTO_RESIZE_NEXT_COLUMN);
			tableInputPopSize.getColumnModel().getColumn(1).setCellEditor(new IntegerEditor(10,10000, new Font("Verdana", Font.PLAIN, 11)));
			tableInputPopSize.setFont(new Font("Verdana", Font.PLAIN, 11));
			//tableInputPopSize.getTableHeader().setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return tableInputPopSize;
	}


	private JScrollPane getScrollVisDisplayOptions(int tabIndex) {
		if (scrollVisDisplayOptions[tabIndex] == null) {
			scrollVisDisplayOptions[tabIndex] = new JScrollPane();
			scrollVisDisplayOptions[tabIndex].setBorder(new LineBorder(Color.black, 1, false));
			scrollVisDisplayOptions[tabIndex].setViewportView(getTableVisDisplayOptions(tabIndex));
			scrollVisDisplayOptions[tabIndex].setBorder(BorderFactory.createEmptyBorder());
			scrollVisDisplayOptions[tabIndex].setVisible((currentActiveTabIndex==TAB_EULERDIAGPOP1SET) || (currentActiveTabIndex==TAB_EULERDIAGPOP2SETS)|| (currentActiveTabIndex==TAB_EULERDIAGPOP2SETS_CONTAINED));
			scrollVisDisplayOptions[tabIndex].setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return scrollVisDisplayOptions[tabIndex];
	}
	
	private JTable getTableVisDisplayOptions(int tabIndex) {

		if (tableVisDisplayOptions[tabIndex] == null) {

			tableVisDisplayOptions[tabIndex] = new JTable(){

				private static final long serialVersionUID = 1L;

				// getTootTipText does not work if placed in new DefaultTableModel
				public String getToolTipText(MouseEvent event){
					return "";
				}
			};

			tableVisDisplayOptions[tabIndex].setColumnSelectionAllowed(true);
			

			/* Cab Problem

			HeterogeneousChannelStyleOutline totalAPopVisStyle = new HeterogeneousChannelStyleOutline("a");
			totalAPopVisStyle.setOutlineColour(HeterogeneousChannelStyle.COLOUR_COLOURBLINDSAFE_RED_DARK);//Color.Blue);
			HeterogeneousChannelStyle[] styles3Sets = EulerEllipseVisStyle.heterogeneousChannelStyle_3Ellipses(COLOUR_BLIND_SAFE) ;
			defaultVisStyle = (new HeterogeneousChannelStyle[]{totalAPopVisStyle, styles3Sets[0], styles3Sets[1], styles3Sets[2]});
			//defaultVisStyle = (new HeterogeneousChannelStyle[]{totalAPopVisStyle, new HeterogeneousChannelStyleSolid("a"), new HeterogeneousChannelStyleTexture("b"), new HeterogeneousChannelStyleOutline("c")});
			JComboBox comboBox = new JComboBox(defaultVisStyle);

			tableVisDisplayOptions[tabIndex].setModel(new DefaultTableModel(new Object[][] { {"Pop", new String("the Red and the Blue cab companies operating in the city"), defaultVisStyle[0]},
																							 {"+vePop", new String("Blue cabs"), defaultVisStyle[1]}, // "+vePop"
																			                 {"-vePop", new String("Red cabs"), defaultVisStyle[2]},  // "-ve Pop"
																			                 {"+veTest", new String("  tests whereby the witness to the accident\n  \n  identified the cab as Blue"), defaultVisStyle[3]},},  //"+veTest"
															      new String[] { "curve", "label", "style", }) {
			*/


			HeterogeneousChannelStyleOutline totalAPopVisStyle = new HeterogeneousChannelStyleOutline("a");
			//HeterogeneousChannelStyleTexture totalAPopVisStyle = new HeterogeneousChannelStyleTexture("a");
						//totalAPopVisStyle.setOutlineColour(HeterogeneousChannelStyle.COLOUR_COLOURBLINDSAFE_BLUE_DARK);
					    totalAPopVisStyle.setOutlineColour(HeterogeneousChannelStyle.COLOUR_COLOURBLINDSAFE_GREEN_DARKDRAB);
						HeterogeneousChannelStyle[] styles3Sets = EulerEllipseVisStyle.heterogeneousChannelStyle_3Ellipses(COLOUR_BLIND_SAFE) ;
						defaultVisStyle = (new HeterogeneousChannelStyle[]{totalAPopVisStyle, styles3Sets[0], styles3Sets[1], styles3Sets[2]});
						//defaultVisStyle = (new HeterogeneousChannelStyle[]{totalAPopVisStyle, new HeterogeneousChannelStyleSolid("a"), new HeterogeneousChannelStyleTexture("b"), new HeterogeneousChannelStyleOutline("c")});
		

			/* Screening Test of an Infection

			tableVisDisplayOptions[tabIndex].setModel(new DefaultTableModel(new Object[][] { {"Pop", new String("the Red and the Blue cab companies operating in the city"), defaultVisStyle[0]},
																							 {"+vePop", new String("infected people"), defaultVisStyle[1]}, // "+vePop"
																							 {"-vePop", new String("uninfected people"), defaultVisStyle[2]},  // "-ve Pop"
																							 {"+veTest", new String("people that had a positive reaction to the test"), defaultVisStyle[3]},},  //"+veTest"
															      new String[] { "curve", "label", "style", }) {
			*/
			
			// Admission
			
			String[] labels = new String[]{"all women\\n(with or without breast cancer)","women with\\nbreast cancer","women without\\nbreast cancer","women with\\npositive mammography"};
			//String[] labels = new String[]{"all cabs (Blue and Red)","Blue cabs","Red cabs","cabs which\\nthe witness\\nidentified as\\nBlue"};
			//String[] labels = new String[]{"all students\\n(choosing either the history or the economics course)","students choosing the economics course","students choosing the history course","students whose decision on pursuing the course was career oriented"};
	
			tableVisDisplayOptions[tabIndex].setModel(new DefaultTableModel(new Object[][] { {"Entire Population", labels[0], defaultVisStyle[0]},//the Red and the Blue cab companies operating in the city"), defaultVisStyle[0]},//women aged forty who participate\\nin routine breast cancer screening"), defaultVisStyle[0]},
																							 {"Hypothesis H", labels[1], defaultVisStyle[1]},//Blue cabs"), defaultVisStyle[1]},//women with\\nbreast cancer"), defaultVisStyle[1]}, // "+vePop"
																							 {"Hypothesis not H", labels[2], defaultVisStyle[2]},//Red cabs"), defaultVisStyle[2]},//women without breast cancer"), defaultVisStyle[2]},  // "-ve Pop"
																							 {"Observation Data", labels[3], defaultVisStyle[3]},},//tests whereby\\nthe witness to\\nthe accident\\nidentified the\\ncab as Blue"), defaultVisStyle[3]},},//women with\\npositive mammography"), defaultVisStyle[3]},},  //"+veTest"
															      new String[] { "curve", "label", "style", }) {

				Class<?>[] types = new Class<?>[] { Object.class, Object.class, Object.class, };
				
				public Class<?> getColumnClass(int columnIndex) {
					return types[columnIndex];
				}

				public boolean isCellEditable(int row, int column){
					if (column == 0){
						return false;
					}
					return true;
				}	
			});	
			tableVisDisplayOptions[tabIndex].getColumnModel().getColumn(0).setPreferredWidth(85);
			tableVisDisplayOptions[tabIndex].getColumnModel().getColumn(1).setPreferredWidth(115);
			tableVisDisplayOptions[tabIndex].getColumnModel().getColumn(2).setPreferredWidth(30);

			
			/*
			// table titles and default VisStyle specific to the tab and thus the visualization
			JComboBox comboBox = new JComboBox(defaultVisStyle);

			tableVisDisplayOptions[tabIndex].setModel(new DefaultTableModel(new Object[][] { {visForNegBR[tabIndex].getSetsTitle()[0], new String(""), defaultVisStyle[0]},
																			                 {visForNegBR[tabIndex].getSetsTitle()[1], new String(""), defaultVisStyle[1]},
																			                 {visForNegBR[tabIndex].getSetsTitle()[2], new String(""), defaultVisStyle[2]}, },
															      new String[] { "curve", "label", "style", }) {

				Class<?>[] types = new Class<?>[] { Object.class, Object.class, Object.class, };

				public Class<?> getColumnClass(int columnIndex) {
					return types[columnIndex];
				}

				public boolean isCellEditable(int row, int column){
					if (column == 0){
						return false;
					}
					return true;
				}
			});
			*/
			
			JComboBox comboBox = new JComboBox(defaultVisStyle);
			comboBox.setFont(new Font("Verdana", Font.PLAIN, 11));
			JTextField textField = new JTextField(labels[0]);
			textField.setFont(new Font("Verdana", Font.PLAIN, 11));
			tableVisDisplayOptions[tabIndex].getColumnModel().getColumn(TABLEVISDISPLAYOPTIONS_STYLE_COLUMN).setCellEditor(new DefaultCellEditor(comboBox));
			tableVisDisplayOptions[tabIndex].getColumnModel().getColumn(TABLEVISDISPLAYOPTIONS_LABELS_COLUMN).setCellEditor(new DefaultCellEditor(textField));
			
			tableVisDisplayOptions[tabIndex].setRowMargin(10);
			tableVisDisplayOptions[tabIndex].setAutoscrolls(false);
			tableVisDisplayOptions[tabIndex].setCellSelectionEnabled(true);
			tableVisDisplayOptions[tabIndex].setRowHeight(25);
			tableVisDisplayOptions[tabIndex].setAlignmentY(1.0f);
			tableVisDisplayOptions[tabIndex].setIntercellSpacing(new Dimension(5, 10));
			tableVisDisplayOptions[tabIndex].setAutoResizeMode(JTable.AUTO_RESIZE_NEXT_COLUMN);
			tableVisDisplayOptions[tabIndex].setFont(new Font("Verdana", Font.PLAIN, 11));
			tableVisDisplayOptions[tabIndex].getTableHeader().setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return tableVisDisplayOptions[tabIndex];
	}

	private JPanel getPanelVisSettingsIcons() {
		if (panelVisSettingsIcons == null) {
			panelVisSettingsIcons = new JPanel();
			panelVisSettingsIcons.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, null, null));
			panelVisSettingsIcons.setToolTipText("Settings for the visualization");
			panelVisSettingsIcons.setLayout(new GroupLayout());
			panelVisSettingsIcons.add(getLabelVisSettingsIcons(), new Constraints(new Leading(6, 10, 10), new Leading(8, 11, 11)));

			panelVisSettingsIcons.add(getLabelIconShape(), new Constraints(new Leading(6, 10, 10), new Leading(31, 11, 11)));
			panelVisSettingsIcons.add(getPanelradiobtnsIconShape(), new Constraints(new Leading(42, 250, 10, 10), new Leading(32, 25, 7, 7)));

			panelVisSettingsIcons.add(getLabelIconDisplayRect(), new Constraints(new Leading(6, 10, 10), new Leading(54, 11, 11)));
			panelVisSettingsIcons.add(getPanelradiobtnsIconDisplayRect(), new Constraints(new Leading(14, 250, 10, 10), new Leading(76, 35, 7, 7)));

			panelVisSettingsIcons.add(getLabelDirection(), new Constraints(new Leading(6, 10, 10), new Leading(119, 11, 11)));
			panelVisSettingsIcons.add(getPanelradiobtnsDirection(), new Constraints(new Leading(14, 280, 10, 10), new Leading(139, 35, 7, 7)));

			panelVisSettingsIcons.add(getLabelIconPlacementStyle(), new Constraints(new Leading(6, 10, 10), new Leading(178, 11, 11)));
			panelVisSettingsIcons.add(getPanelradiobtnsIconPlacementStyle(), new Constraints(new Leading(102, 150, 10, 10), new Leading(173, 25, 7, 7)));

			//panelVisSettingsIcons.add(getLabelGroupIcons(), new Constraints(new Leading(9, 10, 10), new Leading(199, 11, 11)));
			//panelVisSettingsIcons.add(getTextGroupingValue (), new Constraints(new Leading(88, 30, 10, 10), new Leading(198, 15, 7, 7)));
		}
		return panelVisSettingsIcons;
	}

	private JLabel getLabelVisSettingsIcons() {
		if (labelVisSettingsIcons == null) {
			labelVisSettingsIcons = new JLabel();
			labelVisSettingsIcons.setFont(new Font("Verdana", Font.BOLD, 11));
			labelVisSettingsIcons.setText("Visualization Settings");
		}
		return labelVisSettingsIcons;
	}


	private JLabel getLabelIconShape() {
		if (labelIconShape == null) {
			labelIconShape = new JLabel();
			labelIconShape.setFont(new Font("Verdana", Font.PLAIN, 11));
			labelIconShape.setText("Glyph: ");
		}
		return labelIconShape;
	}

	private JPanel getPanelradiobtnsIconShape() {
		if (panelradiobtnsIconShape == null) {
			panelradiobtnsIconShape = new JPanel();
			panelradiobtnsIconShape.setBorder(BorderFactory.createEmptyBorder());
			panelradiobtnsIconShape.setLayout(new GroupLayout());
			int curr_x = 4;
			Rectangle2D iconshapeTextBounds;
			for(int i=0; i<radiobtnIconShape.length; i++){
				//iconshapeTextLen = IconSet.IconShape.values()[i].toString().length();
				iconshapeTextBounds = font.getStringBounds(IconSet.IconShape.values()[i].toString(), context); 
				panelradiobtnsIconShape.add(
						getRadiobtnIconShape(i, IconSet.IconShape.values()[i]==IconSet.IconShape.ELLIPSE), 
										     new Constraints(new Leading(curr_x, (int)(iconshapeTextBounds.getWidth()+30), 10, 10), 
										                     new Leading(0, (int)iconshapeTextBounds.getHeight(), 7, 7)));
				//curr_x += (iconshapeTextLen*10) + 5;
				curr_x += (iconshapeTextBounds.getWidth() + 40);
			}
		}
		return panelradiobtnsIconShape;
	}

	private JRadioButton getRadiobtnIconShape(int index, boolean isSelected) {
		if (radiobtnIconShape[index] == null) {
			radiobtnIconShape[index] = new JRadioButton();
			radiobtnIconShape[index].setSelected(isSelected);
			radiobtnIconShape[index].setText(IconSet.IconShape.values()[index].toString());
			radiobtnIconShape[index].setEnabled(true);
			radiobtnIconShape[index].setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return radiobtnIconShape[index];
	}

	private void initRadiobtngrpIconShape(){
		if (radiobtngrpIconShape == null){
			radiobtngrpIconShape = new ButtonGroup();
			for (int i=0; i<radiobtnIconShape.length; i++){
				radiobtngrpIconShape.add(radiobtnIconShape[i]);
			}
		}
	}

	private JLabel getLabelIconDisplayRect() {
		if (labelIconDisplayRect == null) {
			labelIconDisplayRect = new JLabel();
			labelIconDisplayRect.setFont(new Font("Verdana", Font.PLAIN, 11));
			labelIconDisplayRect.setText("Rectangular Glyphs Display:");
		}
		return labelIconDisplayRect;
	}

	private JPanel getPanelradiobtnsIconDisplayRect() {
		if (panelradiobtnsIconDisplayRect == null) {
			panelradiobtnsIconDisplayRect = new JPanel();
			panelradiobtnsIconDisplayRect.setBorder(BorderFactory.createEmptyBorder());
			panelradiobtnsIconDisplayRect.setLayout(new GroupLayout());
			int curr_x = 0;
			int curr_y = 0;
			//int radiobtnHeight;
			//int iconDisplayRectTextLen = 0;
			Rectangle2D iconDisplayRectTextBounds;
			String radioBtn0text = "glyphs per row";
			iconDisplayRectTextBounds = font.getStringBounds(radioBtn0text, context); 
			panelradiobtnsIconDisplayRect.add(getRadiobtnIconDisplayRect(0, radioBtn0text, false), 
											  new Constraints(new Leading(curr_x, (int)(iconDisplayRectTextBounds.getWidth()+30), 10, 10), 
													  		  new Leading(curr_y, (int)iconDisplayRectTextBounds.getHeight(), 7, 7)));
			panelradiobtnsIconDisplayRect.add(getTextIconDisplayRectIconsPerRow(),
											  new Constraints(new Leading(curr_x+(int)(iconDisplayRectTextBounds.getWidth()+35), 40, 10, 10), 
													          new Leading(curr_y, (int)iconDisplayRectTextBounds.getHeight()+3, 7, 7)));
			curr_y += iconDisplayRectTextBounds.getHeight()+8;
			for(int i=1; i<radiobtnIconDisplayRect.length; i++){
				//iconDisplayRectTextLen = VisUtils.Orientation.values()[i-1].toString().length();
				iconDisplayRectTextBounds = font.getStringBounds(VisUtils.Orientation.values()[i-1].toString(), context); 
				panelradiobtnsIconDisplayRect.add(getRadiobtnIconDisplayRect(i, null, VisUtils.Orientation.values()[i-1] == VisUtils.Orientation.HORIZONTAL),
												  //new Constraints(new Leading(curr_x, iconDisplayRectTextLen*8, 10, 10), new Leading(curr_y, radiobtnHeight, 7, 7)));
													new Constraints(new Leading(curr_x, (int)(iconDisplayRectTextBounds.getWidth()+30), 10, 10), 
															        new Leading(curr_y, (int)(iconDisplayRectTextBounds.getHeight()), 7, 7)));
				//curr_x += (iconDisplayRectTextLen*8)+5;
				curr_x += (iconDisplayRectTextBounds.getWidth() + 50);
			}
		}
		return panelradiobtnsIconDisplayRect;
	}
	
	

	private JRadioButton getRadiobtnIconDisplayRect(int index, String text, boolean isSelected) {
		if (radiobtnIconDisplayRect[index] == null) {
			radiobtnIconDisplayRect[index] = new JRadioButton();
			radiobtnIconDisplayRect[index].setSelected(isSelected);
			radiobtnIconDisplayRect[index].setText((text == null) ? VisUtils.Orientation.values()[index-1].toString() : text);
			radiobtnIconDisplayRect[index].setEnabled(true);
			radiobtnIconDisplayRect[index].setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return radiobtnIconDisplayRect[index];
	}

	private JTextField getTextIconDisplayRectIconsPerRow() {
		if (textIconDisplayRectIconsPerRow == null) {
			textIconDisplayRectIconsPerRow = new JTextField();
			textIconDisplayRectIconsPerRow.setToolTipText("The number of glyphs per row in the rectangular glyph display");
			textIconDisplayRectIconsPerRow.setEnabled(true);
			textIconDisplayRectIconsPerRow.setText("50");
			textIconDisplayRectIconsPerRow.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return textIconDisplayRectIconsPerRow;
	}

	private void initRadiobtngrpIconDisplayRect(){
		if (radiobtngrpIconDisplayRect == null){
			radiobtngrpIconDisplayRect = new ButtonGroup();
			for (int i=0; i<radiobtnIconDisplayRect.length; i++){
				radiobtngrpIconDisplayRect.add(radiobtnIconDisplayRect[i]);
			}
		}
	}

	private JLabel getLabelDirection() {
		if (labelDirection == null) {
			labelDirection = new JLabel();
			labelDirection.setFont(new Font("Verdana", Font.PLAIN, 11));
			labelDirection.setText("Direction:");
		}
		return labelDirection;
	}

	private JPanel getPanelradiobtnsDirection() {
		if (panelradiobtnsDirection == null) {
			panelradiobtnsDirection = new JPanel();
			panelradiobtnsDirection.setBorder(BorderFactory.createEmptyBorder());
			panelradiobtnsDirection.setLayout(new GroupLayout());
			int curr_x = 0;
			int curr_y = 0;
			//int directionTextLen = 0;
			//int radiobtnHeight = 18;
			Rectangle2D directionTextBounds;
			for(int i=0; i<radiobtnDirection.length; i++){
				//directionTextLen = IconDisplay.Direction_Icons_IconRows.values()[i].toStringShort().length();
				directionTextBounds = font.getStringBounds(IconDisplay.Direction_Icons_IconRows.values()[i].toStringShort(), context); 
				panelradiobtnsDirection.add(getRadiobtnDirection(i, IconDisplay.Direction_Icons_IconRows.values()[i]==IconDisplay.Direction_Icons_IconRows.LEFT_TO_RIGHT__TOP_TO_BOTTOM),
											new Constraints(new Leading(curr_x, (int)(directionTextBounds.getWidth()+30), 10, 10), new Leading(curr_y, (int)(directionTextBounds.getHeight()), 7, 7)));
				if (!MathUtils.isMultipleOf(i+1, 4)){ //isEven(i)){
					//curr_x += ((directionTextLen*8) + 2);
					curr_x +=  (int)(directionTextBounds.getWidth()+30+2);
				} else {
					curr_x = 0;
					curr_y += directionTextBounds.getHeight() + 4; //radiobtnHeight;
				}
			}
		}
		return panelradiobtnsDirection;
	}
	

	private JRadioButton getRadiobtnDirection(int index, boolean isSelected) {
		if (radiobtnDirection[index] == null) {
			radiobtnDirection[index] = new JRadioButton();
			radiobtnDirection[index].setSelected(isSelected);
			radiobtnDirection[index].setText(IconDisplay.Direction_Icons_IconRows.values()[index].toStringShort());
			radiobtnDirection[index].setEnabled(true);
			radiobtnDirection[index].setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return radiobtnDirection[index];
	}

	private void initRadiobtngrpDirection(){
		if (radiobtngrpDirection == null){
			radiobtngrpDirection = new ButtonGroup();
			for (int i=0; i<radiobtnDirection.length; i++){
				radiobtngrpDirection.add(radiobtnDirection[i]);
			}
		}
	}


	private JLabel getLabelIconPlacementStyle() {
		if (labelIconPlacementStyle == null) {
			labelIconPlacementStyle = new JLabel();
			labelIconPlacementStyle.setFont(new Font("Verdana", Font.PLAIN, 11));
			labelIconPlacementStyle.setText("Continuous Style:");
		}
		return labelIconPlacementStyle;
	}

	private JPanel getPanelradiobtnsIconPlacementStyle() {
		if (panelradiobtnsIconPlacementStyle == null) {
			panelradiobtnsIconPlacementStyle = new JPanel();
			panelradiobtnsIconPlacementStyle.setBorder(BorderFactory.createEmptyBorder());
			panelradiobtnsIconPlacementStyle.setLayout(new GroupLayout());
			int curr_x = 15;
			//int iconPlacementStyleTextLen = 0;
			for(int i=0; i<radiobtnIconPlacementStyle.length; i++){
				//iconPlacementStyleTextLen = IconDisplay.IconsPlacementStyle.values()[i].toString().length();
				panelradiobtnsIconPlacementStyle.add(getRadiobtnIconPlacementStyle(i, IconDisplay.IconsPlacementStyle.values()[i]==IconDisplay.IconsPlacementStyle.CONTINUOUS_ZIGZAG),
						                             new Constraints(new Leading(curr_x, 70, 10, 10), new Leading(0, 25, 7, 7)));
				curr_x += 70;
			}
		}
		return panelradiobtnsIconPlacementStyle;
	}

	private JRadioButton getRadiobtnIconPlacementStyle(int index, boolean isSelected) {
		if (radiobtnIconPlacementStyle[index] == null) {
			radiobtnIconPlacementStyle[index] = new JRadioButton();
			radiobtnIconPlacementStyle[index].setSelected(isSelected);
			radiobtnIconPlacementStyle[index].setText(IconDisplay.IconsPlacementStyle.values()[index].toString());
			radiobtnIconPlacementStyle[index].setEnabled(true);
			radiobtnIconPlacementStyle[index].setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return radiobtnIconPlacementStyle[index];
	}

	private void initRadiobtngrpIconPlacementStyle(){
		if (radiobtngrpIconPlacementStyle == null){
			radiobtngrpIconPlacementStyle = new ButtonGroup();
			for (int i=0; i<radiobtnIconPlacementStyle.length; i++){
				radiobtngrpIconPlacementStyle.add(radiobtnIconPlacementStyle[i]);
			}
		}
	}


	private JLabel getLabelGroupIcons(){
		if (labelGroupIcons == null){
			labelGroupIcons = new JLabel();
			labelGroupIcons.setFont(new Font("Verdana", Font.PLAIN, 11));
			labelGroupIcons.setText("Group icons by ");
		}
		return labelGroupIcons;
	}

	private JTextField getTextGroupingValue() {
		if (textGroupingValue == null) {
			textGroupingValue = new JTextField();
			textGroupingValue.setToolTipText("The number by which the glyphs should be grouped (the number must be a square integer)");
			textGroupingValue.setEnabled(true);
			textGroupingValue.setText("1");
			textGroupingValue.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return textGroupingValue;
	}



	private JPanel getPanelVisSettingsEuler1Pop() {
		if (panelVisSettingsEuler1Pop == null) {
			panelVisSettingsEuler1Pop = new JPanel();
			panelVisSettingsEuler1Pop.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, null, null));
			panelVisSettingsEuler1Pop.setToolTipText("Settings for the visualization");
			panelVisSettingsEuler1Pop.setLayout(new GroupLayout());

			panelVisSettingsEuler1Pop.add(getLabelVisSettingsEuler1Pop(), new Constraints(new Leading(7, 10, 10), new Leading(5, 11, 11)));
			panelVisSettingsEuler1Pop.add(getChkboxShowPopAsRect(), new Constraints(new Leading(9, 250, 10, 10), new Leading(22, 25, 7, 7)));
			panelVisSettingsEuler1Pop.add(getLabelPlacementOfContainedDiagram(), new Constraints(new Leading(7, 10, 10), new Leading(51, 11, 11)));
			panelVisSettingsEuler1Pop.add(getPanelradiobtnsPlacementOfContainedDiagram(), new Constraints(new Leading(9, 272, 10, 10), new Leading(66, 28, 7, 7)));
		}
		return panelVisSettingsEuler1Pop;
	};

	private JLabel getLabelVisSettingsEuler1Pop() {
		if (labelVisSettingsEuler1Pop == null) {
			labelVisSettingsEuler1Pop = new JLabel();
			labelVisSettingsEuler1Pop.setFont(new Font("Verdana", Font.BOLD, 11));
			labelVisSettingsEuler1Pop.setText("Visualization Settings");
		}
		return labelVisSettingsEuler1Pop;
	}


	private JCheckBox getChkboxShowPopAsRect() {
		if (chkboxShowPopAsRect == null) {
			chkboxShowPopAsRect = new JCheckBox();
			chkboxShowPopAsRect.setSelected(false);
			chkboxShowPopAsRect.setFont(new Font("Verdana", Font.PLAIN, 11));
			chkboxShowPopAsRect.setText("Use a rectangle for the population set");
		}
		return chkboxShowPopAsRect;
	}

    private JPanel getPanelradiobtnsPlacementOfContainedDiagram() {
		if (panelradiobtnsPlacementOfContainedDiagram == null) {
			panelradiobtnsPlacementOfContainedDiagram = new JPanel();
			panelradiobtnsPlacementOfContainedDiagram.setBorder(null); //BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, null, null));
			panelradiobtnsPlacementOfContainedDiagram.setLayout(new GroupLayout());
			int curr_x = 0;
			for(int i=0; i<radiobtnPlacementOfContainedDiagram.length; i++){
				panelradiobtnsPlacementOfContainedDiagram.add(getRadiobtnPlacementOfContainedDiagram(i, null, VisUtils.Placement.values()[i] == VisUtils.Placement.CENTRE),
												              new Constraints(new Leading(curr_x, 10, 10), new Leading(5, 15, 11, 11)));
				curr_x += (1.8 * font.getStringBounds(radiobtnPlacementOfContainedDiagram[i].getText(), context).getWidth());
			}
			panelradiobtnsPlacementOfContainedDiagram.setEnabled(true);
		}
		return panelradiobtnsPlacementOfContainedDiagram;
	}
    

	private JLabel getLabelPlacementOfContainedDiagram() {
		if (labelPlacementOfContainedDiagram == null) {
			labelPlacementOfContainedDiagram = new JLabel();
			labelPlacementOfContainedDiagram.setFont(new Font("Verdana", Font.PLAIN, 11));
			labelPlacementOfContainedDiagram.setText("Placement of Contained Diagram");
		}
		return labelPlacementOfContainedDiagram;
	}

	private JRadioButton getRadiobtnPlacementOfContainedDiagram(int index, String text, boolean isSelected) {
		if (radiobtnPlacementOfContainedDiagram[index] == null) {
			radiobtnPlacementOfContainedDiagram[index] = new JRadioButton();
			radiobtnPlacementOfContainedDiagram[index].setSelected(isSelected);
			radiobtnPlacementOfContainedDiagram[index].setText((text == null) ? VisUtils.Placement.values()[index].toString() : text);
			radiobtnPlacementOfContainedDiagram[index].setEnabled(true);
			radiobtnPlacementOfContainedDiagram[index].setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return radiobtnPlacementOfContainedDiagram[index];
	}

	private void initRadiobtngrpPlacementOfContainedDiagram(){
		if (radiobtngrpPlacementOfContainedDiagram == null){
			radiobtngrpPlacementOfContainedDiagram = new ButtonGroup();
			for(int i=0; i<radiobtnPlacementOfContainedDiagram.length; i++){
				radiobtngrpPlacementOfContainedDiagram.add(radiobtnPlacementOfContainedDiagram[i]);
			}
		}
	}



	private JPanel getPanelVisSettingsCombinedDisplays() {
		if (panelVisSettingsCombinedDisplays == null) {
			panelVisSettingsCombinedDisplays = new JPanel();
			panelVisSettingsCombinedDisplays.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, null, null));
			panelVisSettingsCombinedDisplays.setToolTipText("Settings for the visualization");
			panelVisSettingsCombinedDisplays.setLayout(new GroupLayout());

			panelVisSettingsCombinedDisplays.add(getLabelVisSettingsCombinedDisplays(), new Constraints(new Leading(6, 10, 10), new Leading(8, 11, 11)));
			panelVisSettingsCombinedDisplays.add(getLabelVisSettingsCombinedDisplaysIconPos(), new Constraints(new Leading(8, 117, 10, 10), new Leading(32, 15, 7, 7)));
			panelVisSettingsCombinedDisplays.add(getPanelradiobtnsCombinedDiagIconPosOpts(), new Constraints(new Leading(124, 160, 10, 10), new Leading(27, 25, 7, 7)));
			/*
			panelVisSettingsCombinedDisplays.add(getChkboxShowAreaProportionalEulerDiagram(), new Constraints(new Leading(6, 285, 10, 10), new Leading(26, 25, 7, 7)));
			panelVisSettingsCombinedDisplays.add(getChkboxCentreIconsInRectRegion(), new Constraints(new Leading(6, 285, 10, 10), new Leading(46, 25, 7, 7)));//(30, 25, 7, 7)));
			panelVisSettingsCombinedDisplays.add(getChkboxScaleIconsInRegions(), new Constraints(new Leading(6, 285, 10, 10), new Leading(66, 25, 7, 7)));//(50, 25, 7, 7)));
			*/
			//panelVisSettingsCombinedDisplays.add(getLabelGroupIconsCombinedDisplays(), new Constraints(new Leading(25, 10, 10), new Leading(100, 11, 11)));//(80, 11, 11)));
			//panelVisSettingsCombinedDisplays.add(getTextGroupingValueCombinedDisplays (), new Constraints(new Leading(100, 30, 10, 10), new Leading(98, 15, 7, 7))); //(78, 15, 7, 7)));
		}
		return panelVisSettingsCombinedDisplays;
	};	

	private JLabel getLabelVisSettingsCombinedDisplays() {
		if (labelVisSettingsCombinedDisplays == null) {
			labelVisSettingsCombinedDisplays = new JLabel();
			labelVisSettingsCombinedDisplays.setFont(new Font("Verdana", Font.BOLD, 11));
			labelVisSettingsCombinedDisplays.setText("Visualization Settings");
		}
		return labelVisSettingsCombinedDisplays;
	}

	private JLabel getLabelVisSettingsCombinedDisplaysIconPos() {
		if (labelVisSettingsCombinedDisplaysIconPos == null) {
			labelVisSettingsCombinedDisplaysIconPos = new JLabel();
			labelVisSettingsCombinedDisplaysIconPos.setFont(new Font("Verdana", Font.PLAIN, 11));
			labelVisSettingsCombinedDisplaysIconPos.setText("Glyphs Positioned:");
		}
		return labelVisSettingsCombinedDisplaysIconPos;
	}
	
	private JPanel getPanelradiobtnsCombinedDiagIconPosOpts() {
		if (panelradiobtnsCombinedDiagIconPosOpts == null) {
			panelradiobtnsCombinedDiagIconPosOpts = new JPanel();
			panelradiobtnsCombinedDiagIconPosOpts.setBorder(BorderFactory.createEmptyBorder());
			panelradiobtnsCombinedDiagIconPosOpts.setLayout(new GroupLayout());
			
			for (int i=0; i < EulerPop2SetsIconsForNeglectBaseRate.IconsPositioning.values().length; i++){
				panelradiobtnsCombinedDiagIconPosOpts.add(getRadiobtnsCombinedDiagIconPosOpts(EulerPop2SetsIconsForNeglectBaseRate.IconsPositioning.values()[i].toString() +"ly", i, true), 
						                                   new Constraints(new Leading(83*i, 80, 10, 10), new Leading(0, 25, 10, 10)));
			}
		}
		return panelradiobtnsCombinedDiagIconPosOpts;
	}
	
	private JRadioButton getRadiobtnsCombinedDiagIconPosOpts(String text, int index, boolean isSelected) {
		if (radiobtnCombinedDiagIconPosOpts[index] == null) {
			radiobtnCombinedDiagIconPosOpts[index] = new JRadioButton();
			radiobtnCombinedDiagIconPosOpts[index].setSelected(isSelected);
			radiobtnCombinedDiagIconPosOpts[index].setText((text == null) ? EulerPop2SetsIconsForNeglectBaseRate.IconsPositioning.values()[index].toString() : text);
			radiobtnCombinedDiagIconPosOpts[index].setEnabled(true);
			radiobtnCombinedDiagIconPosOpts[index].setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return radiobtnCombinedDiagIconPosOpts[index];
	}
	
	private void initRadiobtnGrpCombinedDiagIconPosOpts(){
		if (radiobtngrpCombinedDiagIconPosOpts == null){
			radiobtngrpCombinedDiagIconPosOpts = new ButtonGroup();
			for(int i=0; i<radiobtnCombinedDiagIconPosOpts.length; i++){
				radiobtngrpCombinedDiagIconPosOpts.add(radiobtnCombinedDiagIconPosOpts[i]);
			}
		}
	}

	private JCheckBox getChkboxShowAreaProportionalEulerDiagram() {
		if (chkboxShowAreaProportionalEulerDiagram == null) {
			chkboxShowAreaProportionalEulerDiagram = new JCheckBox();
			chkboxShowAreaProportionalEulerDiagram.setSelected(true); //false
			chkboxShowAreaProportionalEulerDiagram.setText("Show area-proportional Euler diagram");
			chkboxShowAreaProportionalEulerDiagram.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return chkboxShowAreaProportionalEulerDiagram;
	}
	private JCheckBox getChkboxCentreIconsInRectRegion() {
		if (chkboxCentreIconsInRectRegion == null) {
			chkboxCentreIconsInRectRegion = new JCheckBox();
			chkboxCentreIconsInRectRegion.setSelected(false);
			chkboxCentreIconsInRectRegion.setText("Centre the glyph block in the region space");
			chkboxCentreIconsInRectRegion.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return chkboxCentreIconsInRectRegion;
	}
	private JCheckBox getChkboxScaleIconsInRegions() {
		if (chkboxScaleIconsInRegions == null) {
			chkboxScaleIconsInRegions = new JCheckBox();
			chkboxScaleIconsInRegions.setSelected(false);
			chkboxScaleIconsInRegions.setText("Scale the icglyphons according to the region space");
			chkboxScaleIconsInRegions.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return chkboxScaleIconsInRegions;
	}

	private JLabel getLabelGroupIconsCombinedDisplays(){
		if (labelGroupIconsCombinedDisplays == null){
			labelGroupIconsCombinedDisplays = new JLabel();
			labelGroupIconsCombinedDisplays.setFont(new Font("Verdana", Font.PLAIN, 11));
			labelGroupIconsCombinedDisplays.setText("Group icons by ");
		}
		return labelGroupIconsCombinedDisplays;
	}

	private JTextField getTextGroupingValueCombinedDisplays() {
		if (textGroupingValueCombinedDisplays == null) {
			textGroupingValueCombinedDisplays = new JTextField();
			textGroupingValueCombinedDisplays.setToolTipText("The number by which the glyphs should be grouped (the number must be a square integer)");
			textGroupingValueCombinedDisplays.setEnabled(true);
			textGroupingValueCombinedDisplays.setText("1");
			textGroupingValueCombinedDisplays.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return textGroupingValueCombinedDisplays;
	}




	private JPanel getPanelShowLabels() {
		if (panelShowLabels == null) {
			panelShowLabels = new JPanel();
			panelShowLabels.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, null, null));
			panelShowLabels.setToolTipText("Label the visualization");
			panelShowLabels.setLayout(new GroupLayout());
			panelShowLabels.add(getLabelLabels(), new Constraints(new Leading(6, 10, 10), new Leading(8, 11, 11)));
			panelShowLabels.add(getChkboxShowSetsLabel(), new Constraints(new Leading(8, 10, 10), new Leading(28, 11, 11)));
			panelShowLabels.add(getChkboxShowRegionSizeLabel(), new Constraints(new Leading(8, 10, 10), new Leading(48, 11, 11)));
			panelShowLabels.add(getPanelradiobtnsShowRegionSizeLabel(), new Constraints(new Leading(23, 261, 10, 10), new Leading(59, 82, 7, 7)));
			panelShowLabels.add(getChkboxShowLegend(), new Constraints(new Leading(8, 10, 10), new Leading(143, 11, 11)));
		}
		return panelShowLabels;
	}

	private JLabel getLabelLabels() {
		if (labelLabels == null) {
			labelLabels = new JLabel();
			labelLabels.setFont(new Font("Verdana", Font.BOLD, 11));
			labelLabels.setText("Labels");
		}
		return labelLabels;
	}


	private JCheckBox getChkboxShowSetsLabel() {
		if (chkboxShowSetsLabel == null) {
			chkboxShowSetsLabel = new JCheckBox();
			chkboxShowSetsLabel.setSelected(true);
			chkboxShowSetsLabel.setText("show the sets' label");
			chkboxShowSetsLabel.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return chkboxShowSetsLabel;
	}

	private JCheckBox getChkboxShowRegionSizeLabel() {
		if (chkboxShowRegionSizeLabel == null) {
			chkboxShowRegionSizeLabel = new JCheckBox();
			chkboxShowRegionSizeLabel.setSelected(false);
			chkboxShowRegionSizeLabel.setText("show the regions' size as: ");
			chkboxShowRegionSizeLabel.setFont(new Font("Verdana", Font.PLAIN, 11));
			chkboxShowRegionSizeLabel.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent event) {
					chkboxShowRegionSizeLabelStateChanged(event);
				}
			});
		}
		return chkboxShowRegionSizeLabel;
	}
	private JPanel getPanelradiobtnsShowRegionSizeLabel() {
		if (panelradiobtnsShowRegionSizeLabel == null) {
			panelradiobtnsShowRegionSizeLabel = new JPanel();
			panelradiobtnsShowRegionSizeLabel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, null, null));
			panelradiobtnsShowRegionSizeLabel.setLayout(new GroupLayout());
			panelradiobtnsShowRegionSizeLabel.add(getRadiobtnShowRegionSizeAsFreq(), new Constraints(new Leading(4, 202, 6, 6), new Leading(13, 16, 7, 7)));
			panelradiobtnsShowRegionSizeLabel.add(getRadiobtnShowRegionSizeAsProbabPercent(), new Constraints(new Leading(4, 10, 10), new Leading(33, 20, 11, 11)));
			panelradiobtnsShowRegionSizeLabel.add(getRadiobtnShowRegionSizeAsProbabDecimal(), new Constraints(new Leading(4, 10, 10), new Leading(53, 20, 11, 11)));
			//panelradiobtnsShowRegionSizeLabel.add(getTextShowRegionSizeTotalFreq(), new Constraints(new Leading(207, 44, 10, 10), new Leading(12, 20, 11, 11)));

			panelradiobtnsShowRegionSizeLabel.setEnabled(chkboxShowRegionSizeLabel.isSelected());
		}
		return panelradiobtnsShowRegionSizeLabel;
	}

	private JRadioButton getRadiobtnShowRegionSizeAsFreq() {
		if (radiobtnShowRegionSizeAsFreq == null) {
			radiobtnShowRegionSizeAsFreq = new JRadioButton();
			radiobtnShowRegionSizeAsFreq.setSelected(true);
			radiobtnShowRegionSizeAsFreq.setText("frequency");// with total population");
			radiobtnShowRegionSizeAsFreq.setEnabled(false);
			radiobtnShowRegionSizeAsFreq.setFont(new Font("Verdana", Font.PLAIN, 11));
			radiobtnShowRegionSizeAsFreq.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent event) {
					radiobtnShowRegionSizeAsFreqStateChanged(event);
				}
			});
		}
		return radiobtnShowRegionSizeAsFreq;
	}

	private JTextField getTextShowRegionSizeTotalFreq() {
		if (textShowRegionSizeTotalFreq == null) {
			textShowRegionSizeTotalFreq = new JTextField();
			textShowRegionSizeTotalFreq.setMargin(new Insets(0, 2, 0, 0));
			textShowRegionSizeTotalFreq.setToolTipText("The frequency for the entire population");
			textShowRegionSizeTotalFreq.setEnabled(false);
			textShowRegionSizeTotalFreq.setText("10000");
			textShowRegionSizeTotalFreq.setFont(new Font("Verdana", Font.PLAIN, 11));
			textShowRegionSizeTotalFreq.addKeyListener(new KeyAdapter() {
				public void keyReleased(KeyEvent event) {
					textShowRegionSizeTotalFreqKeyReleased(event);
				}
			});
		}
		return textShowRegionSizeTotalFreq;
	}

	private JRadioButton getRadiobtnShowRegionSizeAsProbabPercent() {
		if (radiobtnShowRegionSizeAsProbabPercent == null) {
			radiobtnShowRegionSizeAsProbabPercent = new JRadioButton();
			radiobtnShowRegionSizeAsProbabPercent.setText("probability percentage");
			radiobtnShowRegionSizeAsProbabPercent.setEnabled(false);
			radiobtnShowRegionSizeAsProbabPercent.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return radiobtnShowRegionSizeAsProbabPercent;
	}

	private JRadioButton getRadiobtnShowRegionSizeAsProbabDecimal() {
		if (radiobtnShowRegionSizeAsProbabDecimal == null) {
			radiobtnShowRegionSizeAsProbabDecimal = new JRadioButton();
			radiobtnShowRegionSizeAsProbabDecimal.setText("probability between 0 and 1");
			radiobtnShowRegionSizeAsProbabDecimal.setEnabled(false);
			radiobtnShowRegionSizeAsProbabDecimal.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return radiobtnShowRegionSizeAsProbabDecimal;
	}

	private void initRadiobtngrpShowRegionSizeLabel(){
		if (radiobtngrpShowRegionSizeLabel == null){
			radiobtngrpShowRegionSizeLabel = new ButtonGroup();
			radiobtngrpShowRegionSizeLabel.add(radiobtnShowRegionSizeAsFreq);
			radiobtngrpShowRegionSizeLabel.add(radiobtnShowRegionSizeAsProbabPercent);
			radiobtngrpShowRegionSizeLabel.add(radiobtnShowRegionSizeAsProbabDecimal);
		}
	}

	private JCheckBox getChkboxShowLegend() {
		if (chkboxShowLegend == null) {
			chkboxShowLegend = new JCheckBox();
			//chkboxShowLegend.setSelected((currentActiveTabIndex==TAB_ICONDISPLAY) || (currentActiveTabIndex==TAB_EULERPOP2SETS_ICONS));
			chkboxShowLegend.setText("show the diagram's legend");
			chkboxShowLegend.setFont(new Font("Verdana", Font.PLAIN, 11));
			chkboxShowLegend.addItemListener(new ItemListener(){

				@Override
				public void itemStateChanged(ItemEvent e) {
					// TODO Auto-generated method stub
					if (currentActiveTabIndex==TAB_EULERPOP2SETS_ICONS){
						showLegend_EulerPop2SetsIcons = chkboxShowLegend.isSelected();
					}
				}
  			});
		}
		return chkboxShowLegend;
	}


	private JPanel getPanelSave() {
		if (panelSave == null) {
			panelSave = new JPanel();
			panelSave.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED, null, null));
			panelSave.setToolTipText("Save the selected file types for the visualization");
			panelSave.setLayout(new GroupLayout());
			panelSave.add(getLabelSave(), new Constraints(new Leading(6, 10, 10), new Leading(9, 11, 11)));
			panelSave.add(getLabelSaveDir(), new Constraints(new Leading(10, 10, 10), new Leading(38, 11, 11)));
			panelSave.add(getLabelSaveName(), new Constraints(new Leading(10, 44, 10, 10), new Leading(55, 11, 11)));
			panelSave.add(getTextSaveDir(), new Constraints(new Leading(52, 156, 10, 10), new Leading(36, 17, 11, 11)));
			panelSave.add(getTextSaveName(), new Constraints(new Leading(52, 156, 10, 10), new Leading(56, 17, 11, 11)));
			panelSave.add(getButtonSaveBrowse(), new Constraints(new Leading(215, 70, 10, 10), new Leading(34, 22, 11, 11)));
			//panelSave.add(getChkboxSaveAll(), new Constraints(new Leading(10, 6, 6), new Leading(77, 10, 10)));
			//int curr_x = 51 + (int)font.getStringBounds(chkboxSaveAll.getText(), context).getWidth() + 33;
			//int curr_x = 10 + (int)font.getStringBounds(chkboxSaveAll.getText(), context).getWidth() + 33;
			int curr_x = 100;
			for (int i = 0; i < SAVETYPES_COUNT; i++){
				panelSave.add(getChkboxSaveType(i), new Constraints(new Leading(curr_x, 10, 10), new Leading(77, 10, 10)));
				curr_x += (font.getStringBounds(chkboxesSaveTypes[i].getText(), context).getWidth() + 40); //33);
			}
			//panelSave.add(getChkboxSavePNG(), new Constraints(new Leading(60, 10, 10), new Leading(92, 10, 10)));
			//panelSave.add(getChkboxSaveELD(), new Constraints(new Leading(105, 10, 10), new Leading(92, 10, 10)));
			panelSave.add(getButtonSave(), new Constraints(new Leading(215, 70, 10, 10), new Leading(76, 22, 11, 11)));
		}
		return panelSave;
	}

	private JLabel getLabelSave() {
		if (labelSave == null) {
			labelSave = new JLabel();
			labelSave.setFont(new Font("Verdana", Font.BOLD, 11));
			labelSave.setText("Save Current to File");
		}
		return labelSave;
	}

	private JLabel getLabelSaveDir() {
		if (labelSaveDir == null) {
			labelSaveDir = new JLabel();
			labelSaveDir.setText("Folder");
			labelSaveDir.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return labelSaveDir;
	}
	private JLabel getLabelSaveName() {
		if (labelSaveName == null) {
			labelSaveName = new JLabel();
			labelSaveName.setText("Name");
			labelSaveName.setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return labelSaveName;
	}
	private JTextField getTextSaveDir() {
		if (textSaveDir == null) {
			textSaveDir = new JTextField();
			textSaveDir.setFont(new Font("Verdana", Font.PLAIN, 11));
			textSaveDir.setToolTipText("The directory where the files should be saved");
		}
		return textSaveDir;
	}
	private JTextField getTextSaveName() {
		if (textSaveName == null) {
			textSaveName = new JTextField();
			textSaveName.setFont(new Font("Verdana", Font.PLAIN, 11));
			textSaveName.setToolTipText("The name of the files to be saved");
			textSaveName.getDocument().addDocumentListener(new DocumentListener() {
				@Override
				public void insertUpdate(DocumentEvent arg0) {
					// TODO Auto-generated method stub
					textSaveNameInsertUpdate();
				}
				@Override
				public void removeUpdate(DocumentEvent arg0) {
					// TODO Auto-generated method stub
				}
				@Override
				public void changedUpdate(DocumentEvent e) {
					// TODO Auto-generated method stub

				}
  			});
		}
		return textSaveName;
	}
	private JButton getButtonSaveBrowse() {
		if (buttonSaveBrowse == null) {
			Action action_browse = new AbstractAction("browse") {  
			    public void actionPerformed(ActionEvent e) {     
			    	buttonSaveBrowseMouseClicked(e);
			    }
			};
			buttonSaveBrowse = new JButton(action_browse);
			buttonSaveBrowse.setText("browse");
			buttonSaveBrowse.setFont(new Font("Verdana", Font.PLAIN, 11));
			buttonSaveBrowse.setMargin(new Insets(2, 5, 2, 5));
			buttonSaveBrowse.setMnemonic(KeyEvent.VK_B);
			buttonSaveBrowse.getActionMap().put("action_browse", action_browse);
			buttonSaveBrowse.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke(KeyEvent.VK_B, KeyEvent.CTRL_DOWN_MASK), "action_browse"); 
			
			/*
			buttonSaveBrowse.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent event) {
					buttonSaveBrowseMouseClicked(event);
				}
			});
			*/
			/*
			buttonSaveBrowse.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {
					buttonSaveBrowseMouseClicked(event);
				}
			});
			*/
		}
		return buttonSaveBrowse;
	}

	private JCheckBox getChkboxSaveAll() {
		if (chkboxSaveAll == null) {
			chkboxSaveAll = new JCheckBox();
			chkboxSaveAll.setSelected(true);
			chkboxSaveAll.setText(".eld + .png"); //("all ");
			chkboxSaveAll.setFont(new Font("Verdana", Font.PLAIN, 11));
			chkboxSaveAll.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent event) {
					chkboxSaveAllMouseMouseClicked(event);
				}
			});
		}
		return chkboxSaveAll;
	}

	private JCheckBox getChkboxSaveType(int typeIndex) {
		if (chkboxesSaveTypes[typeIndex] == null) {
			chkboxesSaveTypes[typeIndex] = new JCheckBox();
			chkboxesSaveTypes[typeIndex].setText(saveFileTypes[typeIndex]);
			chkboxesSaveTypes[typeIndex].setEnabled(true);
			chkboxesSaveTypes[typeIndex].setSelected(false);
			chkboxesSaveTypes[typeIndex].setFont(new Font("Verdana", Font.PLAIN, 11));
		}
		return chkboxesSaveTypes[typeIndex];
	}

	private JButton getButtonSave() {
		if (buttonSave == null) {
			Action action_save = new AbstractAction("save") {  
			    public void actionPerformed(ActionEvent e) {     
			    	buttonSaveMouseClicked(e);
			    }
			};
			buttonSave = new JButton(action_save);
			buttonSave.setText("save");
			buttonSave.setFont(new Font("Verdana", Font.PLAIN, 11));
			buttonSave.setToolTipText("Save the selected file types for the visualization");
			buttonSave.setMnemonic(KeyEvent.VK_S);
			buttonSave.getActionMap().put("action_save", action_save);
			buttonSave.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke(KeyEvent.VK_S, KeyEvent.CTRL_DOWN_MASK), "action_save"); 

			/*
			buttonSave.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent event) {
					buttonSaveMouseClicked(event);
				}
			});
			*/
			/*
			buttonSave.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {
					buttonSaveMouseClicked(event);
				}
			});
			*/
		}
		return buttonSave;
	}

	private JButton getButtonGenerate() {
		if (buttonGenerate == null) {
			Action action_generate = new AbstractAction("generate") {  
			    public void actionPerformed(ActionEvent e) {     
			    	buttonGenerateMouseClicked(e);
			    }
			}; 
			buttonGenerate = new JButton(action_generate);
			buttonGenerate.setText("Generate");
			buttonGenerate.setFont(new Font("Verdana", Font.PLAIN, 11));
			buttonGenerate.setToolTipText("Generate graphic");
			buttonGenerate.setMnemonic(KeyEvent.VK_G);
			buttonGenerate.getActionMap().put("action_generate", action_generate);
			buttonGenerate.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke(KeyEvent.VK_G, KeyEvent.CTRL_DOWN_MASK), "action_generate"); 
			/*
			buttonGenerate.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent event) {
					buttonGenerateMouseClicked(event);
				}
			});
			*/
			/*
			buttonGenerate.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {
					buttonGenerateMouseClicked(event);
				}
			});
			*/
		}
		return buttonGenerate;
	}
	

	

	// Event Handlers

	private void chkboxShowRegionSizeLabelStateChanged(ChangeEvent event) {
		panelradiobtnsShowRegionSizeLabel.setEnabled(chkboxShowRegionSizeLabel.isSelected());
		radiobtnShowRegionSizeAsFreq.setEnabled(chkboxShowRegionSizeLabel.isSelected());
		//textShowRegionSizeTotalFreq.setEnabled(chkboxShowRegionSizeLabel.isSelected());
		radiobtnShowRegionSizeAsProbabPercent.setEnabled(chkboxShowRegionSizeLabel.isSelected());
		radiobtnShowRegionSizeAsProbabDecimal.setEnabled(chkboxShowRegionSizeLabel.isSelected());
	}

	private void radiobtnShowRegionSizeAsFreqStateChanged(ChangeEvent event){
		//textShowRegionSizeTotalFreq.setEnabled(radiobtnShowRegionSizeAsFreq.isSelected());
	}


	private void textShowRegionSizeTotalFreqKeyReleased(KeyEvent event) {
		try{
			String currText = textShowRegionSizeTotalFreq.getText().trim();
			if (currText.equals("")){return;}
			int i = Integer.parseInt(currText);
			if (i < 0){
				throw new Exception ("Integer is negative");
			}
		} catch (Exception ex){
			JOptionPane.showMessageDialog(this, "The frequency of the total population must be a positive integer", "Labels", JOptionPane.ERROR_MESSAGE);
			textShowRegionSizeTotalFreq.setText("");
		}
	}

	private void buttonSaveBrowseMouseClicked(ActionEvent event){
		JFileChooser chooser = new JFileChooser(selectedSaveDir);
		chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		int returnVal = chooser.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			selectedSaveDir = chooser.getSelectedFile();
		} else {
			return;
		}
		if (!selectedSaveDir.exists()){
			JOptionPane.showMessageDialog(this, "Directory " + selectedSaveDir.getAbsolutePath() + " does not exist", "Save Current to File", JOptionPane.ERROR_MESSAGE);
			return;
		}
		textSaveDir.setText(selectedSaveDir.getAbsolutePath());
	}

	private void textSaveNameInsertUpdate(){
		selectedSaveFileName = textSaveName.getText().trim();
	}

	private void chkboxSaveAllMouseMouseClicked(MouseEvent event) {
		for(int i=0; i<SAVETYPES_COUNT; i++){
			chkboxesSaveTypes[i].setEnabled(!chkboxSaveAll.isSelected());
			chkboxesSaveTypes[i].setSelected(chkboxSaveAll.isSelected());
		}
		//chkboxSaveELD.setEnabled(!chkboxSaveAll.isSelected());
		//chkboxSavePNG.setEnabled(!chkboxSaveAll.isSelected());
	}

	private void buttonSaveMouseClicked(ActionEvent event){
		
		buttonSave.setEnabled(false);

		String dialogTitle = "Save Current to File";

		if (visForNegBR[currentActiveTabIndex].getDisplayPanel().isEmpty()){
			Toolkit.getDefaultToolkit().beep();
			JOptionPane.showMessageDialog(this, "No visualization to save", dialogTitle, JOptionPane.ERROR_MESSAGE);
			buttonSave.setEnabled(true);
			return;
		}

		if ((selectedSaveDir == null) || (selectedSaveFileName == "")){
			Toolkit.getDefaultToolkit().beep();
			JOptionPane.showMessageDialog(this, "Select a directory and a file name", dialogTitle, JOptionPane.ERROR_MESSAGE);
			buttonSave.setEnabled(true);
			return;
		}

		if (!selectedSaveDir.exists()){
			Toolkit.getDefaultToolkit().beep();
			JOptionPane.showMessageDialog(this, "The directory you selected ("+selectedSaveDir.getAbsolutePath()+") does not exist.\nChoose another directory.", dialogTitle, JOptionPane.ERROR_MESSAGE);
			buttonSave.setEnabled(true);
			return;
		}
		
		if (!chkboxesSaveTypes[SAVETYPE_ELD].isSelected() && !chkboxesSaveTypes[SAVETYPE_PNG].isSelected()){
			Toolkit.getDefaultToolkit().beep();
			JOptionPane.showMessageDialog(this, "Select the type of file(s) you want to save", dialogTitle, JOptionPane.ERROR_MESSAGE);
			buttonSave.setEnabled(true);
			return;
		}

		String fileAbsPath = "";
		//if (chkboxSaveAll.isSelected() || chkboxesSaveTypes[SAVETYPE_ELD].isSelected()){
	    if (((currentActiveTabIndex==TAB_EULERDIAGPOP1SET)||(currentActiveTabIndex==TAB_EULERDIAGPOP2SETS_CONTAINED)||(currentActiveTabIndex==TAB_EULERDIAGPOP2SETS)) && 
			  chkboxesSaveTypes[SAVETYPE_ELD].isSelected()){
			fileAbsPath = selectedSaveDir.getAbsolutePath()+File.separator+selectedSaveFileName+saveFileTypes[SAVETYPE_ELD];
			if ((new File(fileAbsPath)).exists()){
				Toolkit.getDefaultToolkit().beep();
				if (JOptionPane.showOptionDialog(this, "File " + fileAbsPath + " already exists.\nDo you want to overwrite it?", dialogTitle,JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, 1)==JOptionPane.NO_OPTION){
					buttonSave.setEnabled(true);
					return;
				}
			}
			
			/*
			if (currentActiveTabIndex ==  TAB_EULERDIAGPOP2SETS_CONTAINED){
				EllipseDiagram diag = ((EulerEllipsePanel)tabPanelsForGraphics[currentActiveTabIndex]).getEulerEllipseDiagram().clone();
				diag.getEllipses().get(3).setLabel("for_white_gap");	
				EllipseDiagramOps.saveDiagToFile2(diag, new File(fileAbsPath));
			} else {
				EllipseDiagramOps.saveDiagToFile2(((EulerEllipsePanel)tabPanelsForGraphics[currentActiveTabIndex]).getEulerEllipseDiagram(), new File(fileAbsPath));
			}
			*/
			refreshEllipsesRefLabelAndVisStyles(currentActiveTabIndex); //this is required, else it would not be possible to save a png for the current panel as soon as it is generated (as the reflabels would be a,a,c instead of a,b,c) and when all the tabs are refreshed together 
			EllipseDiagramOps.saveDiagToFile2(((EulerEllipsePanel)tabPanelsForGraphics[currentActiveTabIndex]).getEulerEllipseDiagram(), new File(fileAbsPath));
		}
		//if (chkboxSaveAll.isSelected() || chkboxesSaveTypes[SAVETYPE_PNG].isSelected()){
		if (chkboxesSaveTypes[SAVETYPE_PNG].isSelected()){
			fileAbsPath = selectedSaveDir.getAbsolutePath()+File.separator+selectedSaveFileName+saveFileTypes[SAVETYPE_PNG];
			if ((new File(fileAbsPath)).exists()){
				Toolkit.getDefaultToolkit().beep();
				if (JOptionPane.showOptionDialog(this, "File " + fileAbsPath + " already exists.\nDo you want to overwrite it?", dialogTitle,JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, 1)==JOptionPane.NO_OPTION){
					buttonSave.setEnabled(true);
					return;
				}
			}
			
			refreshEllipsesRefLabelAndVisStyles(currentActiveTabIndex); //this is required, else it would not be possible to save a png for the current panel as soon as it is generated (as the reflabels would be a,a,c instead of a,b,c) and when all the tabs are refreshed together 
			JPanelUtils.savePanelImgToFile(tabPanelsForGraphics[currentActiveTabIndex], new File(fileAbsPath));
		}

		Toolkit.getDefaultToolkit().beep();
		buttonSave.setEnabled(true);
	}


	private void buttonGenerateMouseClicked(ActionEvent event) {

		boolean showLegend;
		//for (int i = 0; i < TABS_COUNT; i++){
		//for (int i = 0; i < 3; i++){
		//for (int i = currentActiveTabIndex; i <= currentActiveTabIndex; i++){  //to generate the diagram for the current tab only
		for (int i = 0; i < TABS_COUNT; i++){	
			VisForNeglectBaseRate currVisForNegBR = visForNegBR[i];

			currVisForNegBR.setInputProbabs((Double)JTableUtils.GetCellData(tableInputProbabs, TABLEINPUTPROBABS_BASERATE_ROW, TABLEINPUTPROBABS_PROBABS_COLUMN),
											(Double)JTableUtils.GetCellData(tableInputProbabs, TABLEINPUTPROBABS_TESTSENSITIVITY_ROW, TABLEINPUTPROBABS_PROBABS_COLUMN),
											(Double)JTableUtils.GetCellData(tableInputProbabs, TABLEINPUTPROBABS_TESTFALSEPOSITIVE_ROW, TABLEINPUTPROBABS_PROBABS_COLUMN));
			currVisForNegBR.setPopSize((Integer)JTableUtils.GetCellData(tableInputPopSize, 0, 1));
			currVisForNegBR.setDisplayIconShape(IconShape.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpIconShape)]);
			
			refreshEllipsesRefLabelAndVisStyles(i);
			/*
			//currVisForNegBR.setLabels(TypingUtils.typecastObjArrayToTArray(JTableUtils.GetColumnData(tableVisDisplayOptions[i], TABLEVISDISPLAYOPTIONS_LABELS_COLUMN), new String[]{}));
			//currVisForNegBR.setVisStyle(TypingUtils.typecastObjArrayToTArray(JTableUtils.GetColumnData(tableVisDisplayOptions[i], TABLEVISDISPLAYOPTIONS_STYLE_COLUMN), new VisStyle[]{}));
			int[] reqRows = ((i==TAB_EULERDIAGPOP1SET) || (i==TAB_EULERPOP1SET_ICONS)) ? (new int[]{0,1,3}) : (new int[]{1,2,3});
			currVisForNegBR.setLabels(TypingUtils.typecastObjArrayToTArray(JTableUtils.GetColumnData(tableVisDisplayOptions[i], TABLEVISDISPLAYOPTIONS_LABELS_COLUMN, reqRows), new String[]{}));
			//currVisForNegBR.setVisStyle(TypingUtils.typecastObjArrayToTArray(JTableUtils.GetColumnData(tableVisDisplayOptions[i], TABLEVISDISPLAYOPTIONS_STYLE_COLUMN, reqRows), new VisStyle[]{}));
			VisStyle[] visStylesForDiagram = TypingUtils.typecastObjArrayToTArray(JTableUtils.GetColumnData(tableVisDisplayOptions[i], TABLEVISDISPLAYOPTIONS_STYLE_COLUMN, reqRows), new VisStyle[]{});
			String[] vsRefs = new String[]{"a","b","c"};
			for(int j=0; j<visStylesForDiagram.length; j++){
				visStylesForDiagram[j].setRef(vsRefs[j]);
			}
			currVisForNegBR.setVisStyle(visStylesForDiagram);
	        */

			try{
				ShowRegionSizeMode regionSizeLabelDisplayMode = ShowRegionSizeMode.DONOT_SHOW;
				if (chkboxShowRegionSizeLabel.isSelected()){
					if (radiobtnShowRegionSizeAsFreq.isSelected()) {
						regionSizeLabelDisplayMode = ShowRegionSizeMode.SHOW_AS_FREQ;
					} else if (radiobtnShowRegionSizeAsProbabPercent.isSelected()){
						regionSizeLabelDisplayMode = ShowRegionSizeMode.SHOW_AS_PROBAB_PERCENT;
					} else if (radiobtnShowRegionSizeAsProbabDecimal.isSelected()){
						regionSizeLabelDisplayMode = ShowRegionSizeMode.SHOW_AS_PROBAB_DECIMAL;
					}
				}

				if (i == TAB_ICONDISPLAY){
					//((IconDisplayForNeglectBaseRate)visForNegBR[i]).setDisplayIconShape(IconShape.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpIconShape)]);
					((IconDisplayForNeglectBaseRate)visForNegBR[i]).setDisplayDirection_Icons_IconRows(Direction_Icons_IconRows.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpDirection)]);
					((IconDisplayForNeglectBaseRate)visForNegBR[i]).setDisplayIconsPlacementStyle(IconsPlacementStyle.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpIconPlacementStyle)]);
					//((IconDisplayForNeglectBaseRate)visForNegBR[i]).setDisplayGroupingValue(Integer.parseInt(textGroupingValue.getText().trim()));

					//would need to do the same if the user decides to group the icons

					int selectedIndexIconDisplayRect = UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpIconDisplayRect);
					if (selectedIndexIconDisplayRect == 0){
						((IconDisplayForNeglectBaseRate)visForNegBR[i]).setDisplayBestRectFitOrientation(null);
						((IconDisplayForNeglectBaseRate)visForNegBR[i]).setDisplayIconsPerRow(Integer.parseInt(textIconDisplayRectIconsPerRow.getText().trim()));
					} else {
						((IconDisplayForNeglectBaseRate)visForNegBR[i]).setDisplayBestRectFitOrientation(VisUtils.Orientation.values()[selectedIndexIconDisplayRect-1]);
					}
				}

				/* use this when TAB_EULERPOP1SET_ICONS is enabled
				if ((i==TAB_EULERDIAGPOP1SET) || (i==TAB_EULERPOP1SET_ICONS)){
				*/
				if (i==TAB_EULERDIAGPOP1SET){ 
					((EulerPop1SetForNeglectBaseRate)visForNegBR[i]).setShowPopAsRect(chkboxShowPopAsRect.isSelected());
					((EulerPop1SetForNeglectBaseRate)visForNegBR[i]).setPlacementOfContainedDiagram(VisUtils.Placement.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpPlacementOfContainedDiagram)]);
				}

				if (i==TAB_EULERDIAGPOP2SETS_CONTAINED){
					((EulerPop2SetsContainedForNeglectBaseRate)visForNegBR[i]).setShowPopAsRect(chkboxShowPopAsRect.isSelected());
					((EulerPop2SetsContainedForNeglectBaseRate)visForNegBR[i]).setPlacementOfContainedDiagram(VisUtils.Placement.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpPlacementOfContainedDiagram)]);
				}

				if (i==TAB_EULERPOP2SETS_ICONS){
					chkboxShowLegend.setSelected(showLegend_EulerPop2SetsIcons);
				//if ((i==TAB_EULERPOP1SET_ICONS) || (i==TAB_EULERPOP2SETS_ICONS)){
					((EulerPop2SetsIconsForNeglectBaseRate)(visForNegBR[i])).setIconsPositioning (EulerPop2SetsIconsForNeglectBaseRate.IconsPositioning.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpCombinedDiagIconPosOpts)]);
					//((EulerPop2SetsIconsForNeglectBaseRate)visForNegBR[i]).setDisplayIconShape(IconShape.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpIconShape)]);
					
					/*
					((EulerPop2SetsIconsForNeglectBaseRate)(visForNegBR[i])).setShowAreaProportionalEulerDiagram(chkboxShowAreaProportionalEulerDiagram.isSelected());
					((EulerPop2SetsIconsForNeglectBaseRate)(visForNegBR[i])).setCentreIconsInRectRegion(chkboxCentreIconsInRectRegion.isSelected());
					((EulerPop2SetsIconsForNeglectBaseRate)(visForNegBR[i])).setScaleIconsInRegions(chkboxScaleIconsInRegions.isSelected());
		            */
		            //((EulerEllipsePanel)(visForNegBR[i].getDisplayPanel())).setGroupingValue(Integer.parseInt(textGroupingValueCombinedDisplays.getText().trim()));

				} 
				/* enable this when TAB_EULERPOP1SET_ICONS is enabled
				else if (i==TAB_EULERPOP1SET_ICONS){
					((EulerPop1SetIconsForNeglectBaseRate)(visForNegBR[i])).setShowAreaProportionalEulerDiagram(chkboxShowAreaProportionalEulerDiagram.isSelected());
					((EulerPop1SetIconsForNeglectBaseRate)(visForNegBR[i])).setCentreIconsInRectRegion(chkboxCentreIconsInRectRegion.isSelected());
					((EulerPop1SetIconsForNeglectBaseRate)(visForNegBR[i])).setScaleIconsInRegions(chkboxScaleIconsInRegions.isSelected());
					//((EulerEllipsePanel)(visForNegBR[i].getDisplayPanel())).setGroupingValue(Integer.parseInt(textGroupingValueCombinedDisplays.getText().trim()));
				}
				*/
				
				showLegend = ((i==TAB_ICONDISPLAY)||(i==TAB_EULERPOP2SETS_ICONS)) ? chkboxShowLegend.isSelected() : false;

				visForNegBR[i].generate(chkboxShowSetsLabel.isSelected(), regionSizeLabelDisplayMode, showLegend, (Integer)JTableUtils.GetCellData(tableInputPopSize, 0, 1)); //Integer.parseInt(textShowRegionSizeTotalFreq.getText()));//(EulerEllipsePanel)tabPanelsForGraphics[TAB_EULERDIAGPOP2SETS]);
				//Toolkit.getDefaultToolkit().beep();
				// it is safe to just parse textShowRegionSizeTotalFreq.getText() to Integer since verification of input is done on the fly
				
			} catch (Exception e){
			}
		}
		chkboxShowLegend.setSelected((currentActiveTabIndex==TAB_ICONDISPLAY)||(currentActiveTabIndex==TAB_EULERPOP2SETS_ICONS));
		
		//Toolkit.getDefaultToolkit().beep();

/*
		VisForNeglectBaseRate currVisForNegBR = visForNegBR[currentActiveTabIndex];

		currVisForNegBR.setInputProbabs((Double)JTableUtils.GetCellData(tableInputProbabs, TABLEINPUTPROBABS_BASERATE_ROW, TABLEINPUTPROBABS_PROBABS_COLUMN),
				                        (Double)JTableUtils.GetCellData(tableInputProbabs, TABLEINPUTPROBABS_TESTSENSITIVITY_ROW, TABLEINPUTPROBABS_PROBABS_COLUMN),
				                        (Double)JTableUtils.GetCellData(tableInputProbabs, TABLEINPUTPROBABS_TESTFALSEPOSITIVE_ROW, TABLEINPUTPROBABS_PROBABS_COLUMN));

		currVisForNegBR.setLabels(TypingUtils.typecastObjArrayToTArray(JTableUtils.GetColumnData(tableVisDisplayOptions[currentActiveTabIndex], TABLEVISDISPLAYOPTIONS_LABELS_COLUMN), new String[]{}));
		currVisForNegBR.setVisStyle(TypingUtils.typecastObjArrayToTArray(JTableUtils.GetColumnData(tableVisDisplayOptions[currentActiveTabIndex], TABLEVISDISPLAYOPTIONS_STYLE_COLUMN), new VisStyle[]{}));

		try{
			ShowRegionSizeMode regionSizeLabelDisplayMode = ShowRegionSizeMode.DONOT_SHOW;
			if (chkboxShowRegionSizeLabel.isSelected()){
				if (radiobtnShowRegionSizeAsFreq.isSelected()) {
					regionSizeLabelDisplayMode = ShowRegionSizeMode.SHOW_AS_FREQ;
				} else if (radiobtnShowRegionSizeAsProbabPercent.isSelected()){
					regionSizeLabelDisplayMode = ShowRegionSizeMode.SHOW_AS_PROBAB_PERCENT;
				} else if (radiobtnShowRegionSizeAsProbabDecimal.isSelected()){
					regionSizeLabelDisplayMode = ShowRegionSizeMode.SHOW_AS_PROBAB_DECIMAL;
				}
			}

			if (currentActiveTabIndex == TAB_ICONDISPLAY){
				((IconDisplayForNeglectBaseRate)visForNegBR[currentActiveTabIndex]).setDisplayIconShape(IconShape.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpIconShape)]);
				((IconDisplayForNeglectBaseRate)visForNegBR[currentActiveTabIndex]).setDisplayDirection_Icons_IconRows(Direction_Icons_IconRows.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpDirection)]);
				((IconDisplayForNeglectBaseRate)visForNegBR[currentActiveTabIndex]).setDisplayIconsPlacementStyle(IconsPlacementStyle.values()[UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpIconPlacementStyle)]);
				((IconDisplayForNeglectBaseRate)visForNegBR[currentActiveTabIndex]).setDisplayGroupingValue(Integer.parseInt(textGroupingValue.getText().trim()));

				//would need to do the same if the user decides to group the icons

				int selectedIndexIconDisplayRect = UIComponentUtils.getIndexOfSelectedRadioButonInGroup(radiobtngrpIconDisplayRect);
				if (selectedIndexIconDisplayRect == 0){
					((IconDisplayForNeglectBaseRate)visForNegBR[currentActiveTabIndex]).setDisplayBestRectFitOrientation(null);
					((IconDisplayForNeglectBaseRate)visForNegBR[currentActiveTabIndex]).setDisplayIconsPerRow(Integer.parseInt(textIconDisplayRectIconsPerRow.getText().trim()));
				} else {
					((IconDisplayForNeglectBaseRate)visForNegBR[currentActiveTabIndex]).setDisplayBestRectFitOrientation(Orientation.values()[selectedIndexIconDisplayRect-1]);
				}
			}

			visForNegBR[currentActiveTabIndex].generate(chkboxShowSetsLabel.isSelected(), regionSizeLabelDisplayMode, Integer.parseInt(textShowRegionSizeTotalFreq.getText()));
			// it is safe to just parse textShowRegionSizeTotalFreq.getText() to Integer since verification of input is done on the fly
		} catch (Exception e){

		}
*/
	}




	// Static Methods

	private static void installLnF() {
		try {
			String lnfClassname = PREFERRED_LOOK_AND_FEEL;
			if (lnfClassname == null)
				lnfClassname = UIManager.getSystemLookAndFeelClassName(); //CrossPlatformLookAndFeelClassName();
			UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());//lnfClassname);
			//System.out.println(UIManager.getCrossPlatformLookAndFeelClassName());
		} catch (Exception e) {
			System.err.println("Cannot install " + PREFERRED_LOOK_AND_FEEL
					+ " on this platform:" + e.getMessage());
		}
	}

	/**
	 * Main entry of the class.
	 * Note: This class is only created so that you can easily preview the result at runtime.
	 * It is not expected to be managed by the designer.
	 * You can modify it as you like.
	 */
	public static void main(String[] args) {
		installLnF();
		SwingUtilities.invokeLater(new Runnable() {
			@Override
			public void run() {
				Euler4FallaciesWin frameEuler4Fallacies = new Euler4FallaciesWin();
				frameEuler4Fallacies.setDefaultCloseOperation(Euler4FallaciesWin.EXIT_ON_CLOSE);
				//frameEuler4Fallacies.getContentPane().setPreferredSize(frameEuler4Fallacies.getSize());
				frameEuler4Fallacies.pack();
				frameEuler4Fallacies.setLocationRelativeTo(null);
				frameEuler4Fallacies.setVisible(true);
			}
		});
	}

}
