/* 
 * 
 * eulerGlyphs v0.9.0
 * 
 * 2013-12-18
 *
 * 
 * 
 * eulerGlyphs -- Drawing Area-Proportional Euler Diagrams With Glyphs	    
 * 		http://www.eulerdiagrams.org/eulerGlyphs
 * 
 * 
 * 		Copyright (C) 2012-2013, Luana Micallef. 
 * 		All rights reserved.
 * 		
 * 
 * 		This file is part of eulerGlyphs.
 * 			
 * 		eulerGlyphs is free software: you can redistribute it and/or modify
 * 		it under the terms of the GNU General Public License as published 
 * 		by the Free Software Foundation, either version 3 of the License, 
 * 		or (at your option) any later version.
	
 * 		eulerGlyphs is distributed in the hope that it will be useful,
 * 		but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * 		GNU General Public License for more details.
	
 * 		A copy of the GNU General Public License is provided with 
 * 		eulerGlyphs (in a file named 'COPYING'). Alternatively, see 
 * 		<http://www.gnu.org/licenses/gpl.html>.
 * 			
 */

 


package utils;

import java.awt.Dimension;


/**
 *  To instantiate and define a Dimension with Double width and height
 *  
 *  Although class Dimension stores the width and the height as double, the constructor only accepts ints for these properties
 *  To set them as double would have to invoke setSize
 *  => this class extends Dimension by adding a constructor that takes width and height as double 
 *
 */


public class DimensionDouble extends Dimension {
	
	private static final long serialVersionUID = 1L;
	
	// Constructors
	public DimensionDouble(double width, double height){
		super();
		setSize(width, height);
	}
	

	// Setters
	// ... in Dimension both the width would have to be set using setSize. Also, if the actual data members width and height are used, then the values would have to be int not double
	// ... only setSize, getWidth, getHeight use double not int
	public void setWidth(double width){
		this.setSize(width, this.getHeight());
	}
	public void setHeight(double height){
		this.setSize(this.getWidth(), height);
	}
	

}
