/* 
 * 
 * eulerGlyphs v0.9.0
 * 
 * 2013-12-18
 *
 * 
 * 
 * eulerGlyphs -- Drawing Area-Proportional Euler Diagrams With Glyphs	    
 * 		http://www.eulerdiagrams.org/eulerGlyphs
 * 
 * 
 * 		Copyright (C) 2012-2013, Luana Micallef. 
 * 		All rights reserved.
 * 		
 * 
 * 		This file is part of eulerGlyphs.
 * 			
 * 		eulerGlyphs is free software: you can redistribute it and/or modify
 * 		it under the terms of the GNU General Public License as published 
 * 		by the Free Software Foundation, either version 3 of the License, 
 * 		or (at your option) any later version.
	
 * 		eulerGlyphs is distributed in the hope that it will be useful,
 * 		but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * 		GNU General Public License for more details.
	
 * 		A copy of the GNU General Public License is provided with 
 * 		eulerGlyphs (in a file named 'COPYING'). Alternatively, see 
 * 		<http://www.gnu.org/licenses/gpl.html>.
 * 			
 */

 


package utils;

import java.util.ArrayList;


/**
 * 
 * Matrices Operations and Utilities
 *
 */


public class MatricesUtils {

	public static <T>T[][] arrayToMatrixGivenNoOfRows (T[] array, int noOfRows, T[][] sampleTypeOutputArray){
		
		int noOfCols = MathUtils.roundup(array.length / noOfRows);
		Object[][] matrix  = new Object[noOfRows][noOfCols];
		
		for(int r=0; r < noOfRows; r++){
			for(int c=0; c<noOfCols; c++){
				matrix[r][c] = array[(r*noOfCols)+c];
			}
		}
		return (T[][]) matrix;
	}

	
	public static <T>T[] matrixToArray (T[][] matrix){
		int noOfRows = matrix.length;
		int noOfCols = matrix[0].length;

		ArrayList<T> list = new ArrayList<T>();
		for(int r=0; r < noOfRows; r++){
			for(int c=0; c<noOfCols; c++){
				list.add(matrix[r][c]);
			}
		}
		return TypingUtils.typecastObjArrayToTArray(list.toArray(), matrix[0]);
	}
	
	public static <T>T[][] transpose (T[][] matrix){
		int noOfRows_inputMatrix = matrix.length;
		int noOfCols_inputMatrix = matrix[0].length;
		
		ArrayList<T[]> transposeMatrixAsList = new ArrayList<T[]>(); 
		ArrayList<T> transposeMatrixRow;
		for (int c =0; c<noOfCols_inputMatrix; c++){
			transposeMatrixRow = new ArrayList<T>(noOfRows_inputMatrix);
			for (int r=0; r<noOfRows_inputMatrix; r++){
				transposeMatrixRow.add(matrix[r][c]);
			}
			transposeMatrixAsList.add(TypingUtils.typecastObjArrayToTArray(transposeMatrixRow.toArray(), matrix[0]));
		}
		
		return TypingUtils.typecastObjArrayToTArray(transposeMatrixAsList.toArray(),matrix);
	}
}
